!F2F:NO_TOUCH!

!   1 - Auxiliary JUMP - package (setjmp, longjmp) :
! ----------------------------------------------------
Module Long_Jump
      integer*4 jmp_buf(20) /20*0/
      character *256 extended_err_msg
      Interface
        integer function setjmp(jmpbuf)
!DEC$     ATTRIBUTES ALIAS : '__setjmp' :: setjmp
!DEC$     ATTRIBUTES REFERENCE :: jmpbuf
          integer*4 jmpbuf(20)
        end function setjmp
        subroutine longjmp(jmpbuf,code)
!DEC$     ATTRIBUTES ALIAS : '_longjmp' :: longjmp
!DEC$     ATTRIBUTES REFERENCE :: jmpbuf
!DEC$     ATTRIBUTES VALUE :: code
          integer*4 code, jmpbuf(20)
        end subroutine longjmp
      end Interface
End module long_jump


!  2 - Windows Handle Support routine
! ----------------------------------------------------
!   SYS idea for getting Windows Handle of just opened file
!   (solution of specific trouble with logical unit number 
!   passed as parameter to standalone collected DLL).
!   Exchange will be performed via C-written Write_String routine

Module WHandle_Support
integer *4 fHandle

Contains
  INTEGER FUNCTION UOPEN( FILENAME,DESIRED_ACCESS,SHARE_MODE,A_NULL,CREATE_DISP,FLAGS_ATTR,B_NULL,UNIT,FLEN )
! !DEC$ ATTRIBUTES DLLEXPORT::UOPEN
!DEC$ ATTRIBUTES C, ALIAS:'_UOPEN' :: UOPEN
!DEC$ ATTRIBUTES REFERENCE :: FILENAME
!DEC$ ATTRIBUTES REFERENCE :: DESIRED_ACCESS
!DEC$ ATTRIBUTES REFERENCE :: SHARE_MODE
!DEC$ ATTRIBUTES REFERENCE :: CREATE_DISP
!DEC$ ATTRIBUTES REFERENCE :: FLAGS_ATTR
!DEC$ ATTRIBUTES REFERENCE :: UNIT

	USE DFWIN

	IMPLICIT INTEGER (A-Z)
	CHARACTER*(FLEN) FILENAME
	TYPE(T_SECURITY_ATTRIBUTES), POINTER :: NULL_SEC_ATTR

	! Set the FILE_FLAG_WRITE_THROUGH bit in the flag attributes to CreateFile( )
	! (for whatever reason)
	!FLAGS_ATTR = FLAGS_ATTR + FILE_FLAG_WRITE_THROUGH
	!CREATE_DISP = OPEN_EXISTING
	!SHARE_MODE = FILE_SHARE_WRITE

	! Do the CreateFile( ) call and return the status to the Fortran rtl
	fHandle = CreateFile( FILENAME,DESIRED_ACCESS,SHARE_MODE,NULL_SEC_ATTR,CREATE_DISP,FLAGS_ATTR,0 )
	UOPEN = fHandle
	RETURN
	END FUNCTION UOPEN

End module WHandle_Support


!    Main module  connected with F2F convertor :
! ----------------------------------------------------

Module ComFort
  Parameter(MaxLBuf=1600)            ! the same as in CompuServ.dpr
  Parameter(MaxIBuf=MaxLBuf/4)
  Parameter(TextOffset=4)
     
  Character*16 cf_DllName/'???'/     ! Name of currently running DLL 
  
  integer*4 cf_CurUnit/0/            ! current unit performed I/O            (formerly sc_hndl(6)) 
  integer*4 cf_RecCnt(1000)/1000*0/  ! record counters for active Units     
  integer*4 cf_FHandle(1000)/1000*0/ ! Open File Handles     

  integer*4 cf_Job                   ! I/O job: write(1), read(3), debug(2) 
  integer*4 cf_MainHandle            ! Main Thread Handle
  integer*4 cf_ConsoleStatus/-1/     ! undefined(=0), console(<0), GUI(>0)   (formerly Mode_Job) 
  integer*4 cf_BufInt(8*MaxIBuf)     ! I don't want to pass CHARACTERs into Pascal !!! 
  Character*MaxLBuf cf_BufIO/' '/    ! Main IO-buffer                        (formerly ascii_buf)
  Equivalence (cf_BufInt(1),cf_Job)
  Equivalence (cf_BufInt(2),cf_MainHandle)
  Equivalence (cf_BufInt(3),cf_ConsoleStatus)
  Equivalence (cf_BufInt(TextOffset),cf_BufIO)
  Logical cf_Injected/.false./
  Character*MaxLBuf cf_InjectedLine
  Integer*4 cf_InjectedInt(MaxIbuf)
  Equivalence (cf_InjectedInt(1),cf_InjectedLine)
!
  Character*256 cf_EBuf/' '/         ! Auxiliary IO-buffer                   (formerly e_buf)
  Character*256 cf_Params            ! path to main datafile passed to Server(formerly DLL_Param) 
  Character*4 cf_SpecOutput/'%%%<'/  ! mark for interpretation on Client-side
  Integer*4 Termination_Type/0/

!    stuff for files opening :
  Character*256 fo_HomePath/' '/     ! where NameFile lives
  Character*256 fo_FilePath/' '/     ! where current file look for
  Character*256 fo_FileName/' '/     ! file name (without extension)
  Character*256 fo_FileExt /' '/     ! extension (with "." if present)
  Character*256 fo_FullName/' '/     !
  Integer*4     fo_Logging /-1/      ! where to write "Log" or block it  if < 0
  Integer*4     fo_error   /0/       ! Error code if > 0
  Character*256 fo_MessEr  /' '/     ! Extended Error Message if fo_error>0
!    specially for WHI :
  Character*256 fo_NamePrefix/''/    ! for 1-st attempt while Open_File without Path
  Character*256 fo_NameSuffix/''/    ! for 2-nd attempt while Open_NameFile 
  Character*36  fo_BinarExt/' '/     ! unformatted treated as Binary

!
!   for compatibility with  old P_Client
!      
!      Par_DLL area in Main Thread :
!  TLinkArea = record          // see FOR2DLL :  common / Link_Area /...
!    mode_job:LongInt;         //    mode_job : GUI (>0) or CONSOLE (<0)
!    s_handle:LongInt;         //    1 - fortran thread number (TServer)
!    c_handle:LongInt;         //    2 - pascal  thread number (TClient)
!    DLL_Code:LongInt;         //    3 - First parameter passed to DLL (integer)
!        LBuf:LongInt;         //    4 - I/O buffer size (set in DLL)
!     jobtype:LongInt;         //    5 - message type (read,write)
!    cur_unit:LongInt;         //    6 - Current active unit number
!    ERR_Code:LongInt;         //    7 - How Server finished (0-OK);
!      reserv:array[1..28] of LongInt;  // free hole
!    CParam:array[0..3999] of char;// 36 - Arbitrary additional parameters
!        mess:ShortString;     //   1036 - short buffer for Read...
!         buf:array[0..999] of char;   //    I/O buffer used in DLL
! 
  integer*4 cf_OldLinkArea(1100)
  character*256 cf_OldMess,cf_OldParams
  equivalence(cf_RunCode,cf_oldlinkarea(4))      ! integer parameter passed to DLL
  equivalence(cf_oldparams,cf_oldlinkarea(37))   ! full path to Project
  equivalence(cf_oldmess,cf_oldlinkarea(1037))   ! message passing area


Contains

      Function Init_cf(job)               !  initial(job<>0) or final(job=0) Entry into DLL. 
      use Long_Jump
      use DFWIN                           !  for ConsoleAllocation 
      use DFLIB                           !  for SetControlFPQQ
      integer*4 job(MaxIBuf)              !  parameters passed from Computational Server
      do  i=1,MaxIBuf                     !  actually it is character line !
        cf_BufInt(i)=job(i)               !  but we avoid to pass more than 1 parameter !
      enddo                               !  
      cf_Params=cf_BufIO                  !  the  parameter line passed to DLL
      cf_Injected = .false.

      if(cf_Job.eq.0) then                !  spec Entry for free resources after Exception
        Termination_Type=1                !  Math.Exception.  Text ready in cf_BufIO
        Call cf_Instead_of_Stop
		Init_cf=-1
        Return
      endif	
	  	    
      cf_ConsoleStatus=job(1)             ! 1-old P_Client,  2- COM server,  -1:console appl.
	  if(cf_ConsoleStatus.eq.1) then      ! DLL's not called via cf_Init (like MFReader) 
        do i=1,1100                       ! have cf_ConsoleStatus=-1     (real Console)
          cf_OldLinkArea(i)=job(i)
        enddo
	    cf_MainHandle=job(3)              
        cf_Params=cf_OldParams
	    cf_OldLinkArea(5)=4000
	    cf_OldLinkArea(36)=1099
      endif
      i=setjmp(jmp_buf)                   !  Remember return address
      Init_cf=i
	  if(i.ne.0) Return                   !  After LongJump

	  do i=1,1000
        cf_RecCnt(i)=0
        cf_FHandle(i)=0
      enddo
      cf_BufIO=''                         ! clear I/O buffer
      fo_HomePath=' '
      fo_Logging=-1
      Termination_Type=5                  ! assume User-Error before "Normal_Termination"
      if(cf_ConsoleStatus.lt.0) i=AllocConsole()
      i=1                                 ! Canonize DLL parameter: 
      do while(i.lt.256.and.cf_Params(i:i).eq.' ')
        i=i+1                             ! 1-st non-blan
      enddo
      j=i
      do while(j.lt.256.and.ichar(cf_Params(j:j)).ge.ichar(' '))
        j=j+1                             ! 1-st bad char
      enddo
      cf_Params=cf_Params(i:j-1)          ! remove bad chars
      call SetControlFPQQ(#1372)          ! set default FPU regime
      Return                              ! now DLL really starts
      End Function Init_cf
! ----------------------------------------
      Subroutine Debug(text)
!DEC$ ATTRIBUTES C,REFERENCE, ALIAS: '_ShowMessage' :: ShowMessage
	  Character*(*) text
      call ShowMessage(text)
	  Return
	  End Subroutine Debug

      Subroutine WHI_SpecialSettings(itype)              ! 1:UnSat, 2:VMod, -3,3:MFReader
      Character*256 LogFile
      LogFile=Trim(cf_Params)//'.Log'
      if(itype.eq.-3) LogFile=Trim(cf_Params)//'.MFR.Log'
      if(itype.eq.3) LogFile='+'//Trim(cf_Params)//'.MFR.Log'
      fo_BinarExt='HDSDDNUCNFLOFTLHVTDVTCBMCCMSIGCBB~~~' ! default WHI-extensions for Binary files
      fo_NamePrefix=Trim(cf_Params)//'.'                 ! default WHI relative filename prefix 
      fo_NameSuffix='.modflow.in'                        ! default ModFlow NameFile 
      if(itype.eq.1) then
        fo_NameSuffix='.dat'                             ! default UnSat NameFile
        cf_Params=cf_DllName
      endif
      call Open_LogFile(1000,LogFile)                    ! default logging
      cf_CurUnit=0
      if(itype.eq.2) then
        cf_BufIO='%%%<START'                             ! Engine started
	    call Interface_IO(1)                             ! special VMod Event
      endif 
	  Return
	  End Subroutine WHI_SpecialSettings

! ----------------------------------------
      Subroutine Inject_Line_From_Outside(m)! set new values of External Parameters
!DEC$ IF DEFINED (PIVOT)
!DEC$   ATTRIBUTES DLLEXPORT :: Inject_Line_From_Outside
!DEC$   ATTRIBUTES ALIAS : 'Inject_Line_From_Outside' :: Inject_Line_From_Outside
!DEC$ ENDIF
      integer*4 m(*)
      do i=1,MaxIBuf
        cf_InjectedInt(i)=m(i+TextOffset-1)                    ! see TLinkArea:  some integers before text
      enddo
      cf_Injected = .true.
      return
      End Subroutine Inject_Line_From_Outside
! ----------------------------------------
      Subroutine Normal_Termination    ! Use it instead of final "STOP" 
      use Long_Jump
      character*80 mark
	  character*6 m/'ERROR '/
	  real*4 t
	  m='DONE '
      Termination_Type=0               ! OK
      cf_BufIO=' '                     ! without own final message
      goto 1
! ----------
      Entry SelfKiller                 ! Terminate DLL from outside
!DEC$ IF DEFINED (PIVOT)
!DEC$   ATTRIBUTES DLLEXPORT :: SelfKiller
!DEC$   ATTRIBUTES ALIAS : 'SelfKiller' :: SelfKiller
!DEC$ ENDIF
      Termination_Type=2               ! killed
      cf_BufIO=' '                     ! without own final message
      goto 1
! ----------
      ENTRY cf_IO_Error                ! called from inside of DLL
      Termination_Type=3               ! 'I/O Error   '
      if(cf_BufIO.ne.' ') then
	    if(fo_error.eq.0) cf_BufIO=' current processed record:'//cf_BufIO
		call Interface_IO(1)           ! 3 lines of swearing
      endif
      goto 3
! ----------
      ENTRY cf_Eof_Read                ! called from inside of DLL
      Termination_Type=4               ! 'End of File '   (2 lines of swearing)
  3   cf_BufIO=''
      if(cf_CurUnit.gt.0) then
        cf_BufIO='Error on unit 0000 record 000000 in file ' 
        Write(cf_BufIO(15:18),'(i4)',err=4) cf_CurUnit
        if(cf_CurUnit.gt.1000) goto 5
        Write(cf_BufIO(27:32),'(i6)',err=4) cf_RecCnt(cf_CurUnit)-1 
  5     inquire(unit=cf_CurUnit,name=cf_BufIO(42:140),err=4)
  4     call Interface_IO(1)  
      endif
! ----------------------------------------
      Entry cf_Instead_of_STOP                  ! called from inside of DLL
  1   cf_CurUnit=0                              ! always to Console !
      if(cf_BufIO.ne.' ') call Interface_IO(1)  ! write final message if given 
!DEC$ IF DEFINED (PIVOT)
      call Free_Memory                          ! return arrays if needed 
!DEC$ ENDIF
      call CPU_Time(t) 
      Write(mark,'(A,A,5hTime:,f9.1,5h sec.,2X,A)',err=7) cf_SpecOutput,m,t,cf_DLLName
  7   cf_BufIO=Trim(mark)//' finished by STOP in DLL.'
      if(Termination_Type.eq.0) cf_BufIO=Trim(mark)//' finished successfully.'
      if(Termination_Type.eq.1) cf_BufIO=Trim(mark)//' aborted by Math.Exception: '//cf_Params
      if(Termination_Type.eq.2) cf_BufIO=Trim(mark)//' terminated by User.'
      if(Termination_Type.eq.3) cf_BufIO=Trim(mark)//' I/O Error in '//cf_Ebuf
      if(Termination_Type.eq.4) cf_BufIO=Trim(mark)//' End of File in '//cf_Ebuf
      CALL Interface_IO(1)                      ! final special message 
      do i=1,1000                               ! closing all own opened files
        if(cf_RecCnt(i).ne.0) call Close_File(i)
      enddo 
      cf_ConsoleStatus=-1                       ! restore default 
      cf_Injected=.false.
      if(Termination_Type.ne.1) call longjmp(jmp_buf,-1) ! Return outside from anywhere
      RETURN                                    ! after abnormal termination  
      END Subroutine Normal_Termination

! ----------------------------------------
      Subroutine Buffer_Out(n1,n2)
!DEC$ ATTRIBUTES C,REFERENCE, ALIAS: '_Post_Message' :: Post_Message
!DEC$ ATTRIBUTES C,REFERENCE, ALIAS: '_Send_Message' :: Send_Message
      if(n1.gt.n2) return
      if(cf_ConsoleStatus.eq.1) then
        cf_OldLinkArea(6)=cf_job                                 ! jcWrite or Debug for old P_Client
        cf_OldMess=Char(n2-n1+1)//cf_BufIO(n1:n2)                ! ShortString
        call Send_Message(cf_MainHandle,cf_OldLinkArea)          ! synchronously
        return
	  endif
      if(cf_CurUnit.le.0) write(*,1,err=2) cf_BufIO(n1:n2)          ! real console case
      if(cf_CurUnit.gt.0) write(cf_CurUnit,1,err=2) cf_BufIO(n1:n2) ! write to file
  1   format(1X,A)
  2   Return
      End Subroutine Buffer_Out

      Subroutine Interface_IO(job)                 ! 1:write, 2:debug, 3:read,  ... somewhat else?
      Integer*4 job
!DEC$ ATTRIBUTES C,REFERENCE, ALIAS: '_Post_Message' :: Post_Message
!DEC$ ATTRIBUTES C,REFERENCE, ALIAS: '_Send_Message' :: Send_Message
      cf_job=job
      if(job.eq.3) goto 3
      if(cf_ConsoleStatus.eq.2) then
        CALL Post_Message(cf_MainHandle,cf_job)      ! Send order for Main Thread to perform I/O
        do while (cf_job.ne.0)                       ! waiting while finish I/O  
          call sleepqq(10)                           ! (main Thread MUST clear cf_job) 
        enddo	 
        return
	  endif 
      n1=1
      n2=0
      if(cf_BufIO(1:1).eq.' ') n1=2                    ! maybe 1-st blank put by Fortran ! 
      do i=1,MaxLBuf
        if(cf_BufIO(i:i).eq.Char(250)) then            ! Char(250) simulates "/" in formats
          Call Buffer_Out(n1,n2) 
          n1=i+1
        endif
        if(cf_BufIO(i:i).ne.' ' ) n2=i 
      enddo
      Call Buffer_Out(n1,n2) 
!      cf_BufIO=''                                      ! clear I/O buffer
	  return

   3  if(cf_ConsoleStatus.lt.1) then
        if(cf_CurUnit.eq.0) read(*,'(A)') cf_BufIO     ! real console or Formatted File Read
        if(cf_CurUnit.gt.0) read(cf_CurUnit,'(A)') cf_BufIO 
      endif
      if(cf_ConsoleStatus.eq.1) then
 	    cf_OldLinkArea(6)=0                            ! jcRead
		cf_OldMess=Char(0) 
        call Send_Message(cf_MainHandle,cf_OldLinkArea)! Syncronously!
        n2=IChar(cf_OldMess(1:1))
	    cf_BufIO=cf_OldMess(2:n2+1)      
      endif
      if(cf_ConsoleStatus.eq.2) then
        CALL Post_Message(cf_MainHandle,cf_job)      ! Send order for Main Thread to perform I/O
        do while (cf_job.ne.0)                       ! waiting while finish I/O  
          call sleepqq(10)                           ! (main Thread MUST clear cf_job) 
        enddo	 
      endif
      Call Write_LogFile(cf_BufIO)                     ! Logging (maybe not needed?) 
      Return
      End Subroutine Interface_IO

! ----------------------------------------

      Subroutine cf_NewUnit(Lun)                ! New logical Unit appears (OPEN)
      Use WHandle_Support
      integer*4 Lun
      cf_CurUnit=Lun
      if(Lun.ge.1.and.Lun.le.1000) then
	    cf_RecCnt(Lun)=1                        ! initial record counter for active unit
        cf_FHandle(Lun) = fHandle               ! remember for WriteStringByHandle
		fHandle=0
      endif
      return
      End Subroutine cf_NewUnit

      Subroutine cf_NewRecord(Lun)              ! Read/Write new record on current Unit
      integer*4 Lun
      cf_CurUnit=Lun
      if(Lun.ge.1.and.Lun.le.1000) cf_RecCnt(Lun)=cf_RecCnt(lun)+1 ! increase record counter for active unit
      return
      End Subroutine cf_NewRecord
!
! -------------- stuff for opening files ------------------
!
      Subroutine fo_SplitFileName(name)
      Character*(*) name
      Integer*4 i,j,k,p1,p2,p3
      Character*256 fn
      Character*8 badchars/':*?<>"''|'/
      fo_FilePath=''
      fo_FileName=''
      fo_FileExt='    '
      fo_error=1       ! Illegal File Name
      fo_MessEr='Illegal FileName: '//name
      j=Len_Trim(name) ! last non-blan
      if((name(j:j).eq.'''').or.(name(j:j).eq.'"')) j=j-1    ! maybe quotas
      i=1
      do while ((i.lt.j).and.(name(i:i).eq.' '))
        i=i+1          ! 1-st non-blan
      enddo
      if((name(i:i).eq.'''').or.(name(i:i).eq.'"')) i=i+1    ! maybe quotas
      k=j-i+1
      fn=name(i:j)     ! K characters without left blanks
      p1=0
      p2=0
      p3=0
      do i=1,k                           ! check for legal FileName
        if(fn(i:i).eq.'/') fn(i:i)='\'   ! replace Unix-style "/"
        j=IChar(fn(i:i))                 ! and UpperCase
        if(j.ge.IChar('a').and.j.le.IChar('z')) fn(i:i)=Char(j+IChar('A')-IChar('a'))
        j=Index(badchars,fn(i:i))
        if(ichar(fn(i:i)).lt.ichar(' ') .or. j.gt.1) goto 999   ! illegal
        if(j.eq.1) then
          p1=2                           ! position ":" after Disk-letter 
          if(fn(1:2).eq.'\\') p1=Index(fn,':')
          if(i.gt.p1) goto 999           ! 2-nd ":"
        endif
        if(fn(i:i).eq.'\') p2=i
        if(fn(i:i).eq.'.') p3=i
      enddo
	  fo_MessEr='UNC paths are not allowed!'
	  if(fn(1:2).eq.'\\') goto 999       ! for a while ...
      fo_FullName=fn
      fo_error=0
      fo_MessEr=''
      fo_FilePath=''
      fo_FileExt='    '
      if(p3.gt.0) then
        fo_FileExt=fn(p3:k)
        fn(p3:k)='            '
        k=p3-1
      endif
      fo_FileName=fn(p1+1:k)
      if(p2.gt.p1) then
        fo_FilePath=fn(1:p2-1)
        fo_FileName=fn(p2+1:k)
      endif
  999 if(fo_error.ne.0) call Write_LogFile('')
      End Subroutine fo_SplitFileName

      Subroutine Write_LogFile(text)
	  character*(*) text
      character*256 mess
      integer*4 n
      if(fo_Logging.le.0) goto 1
	  mess=text
	  if(mess.eq.'') then ! take it from fo_MessEr
        mess='Error XXX in File_Open: '//fo_MessEr
        write(mess(7:9),'(i3)',err=7) fo_error
        if(fo_error.eq.0) mess=fo_MessEr
        if(fo_error.ne.0) cf_BufIO=fo_MessEr
      endif
  7   n=Len_Trim(mess)
      Write(fo_Logging,'(A)',err=1) mess(1:n)        
  1   return
      End Subroutine Write_LogFile

      Subroutine Open_LogFile(Lun,name) !  if FileName starts with "+" open as "APPEND" !!! 
      Use WHandle_Support
      Character*(*) name
      Integer*4 Lun
      character*256 file,access
!   ---------
      if(fo_Logging.gt.0) Close(fo_Logging,err=11) ! to permit logging request more than once !
  11  fo_Logging=-1                                ! block logging for a while
      if(Lun.lt.1.or.name.eq.'') return            ! stop logging
      file=name
      access='sequential'
      if(name(1:1).eq.'+') then
        file=file(2:256)
        access='APPEND'
      endif

      Call fo_SplitFileName(file)
      if(fo_error.ne.0) goto 1  
      open(Lun,file=fo_FullName,err=9,status='unknown',form='FORMATTED',iostat=fo_error,access=access,useropen=UOPEN) 
      goto 2
  9   fo_MessEr='Cannot open LogFile '//Trim(fo_FullName)//'    Try to open in current directory ...'
      fo_FullName=fo_FileName
      if(fo_FileExt(1:1).eq.'.') fo_FullName=Trim(fo_FullName)//fo_FileExt
      open(Lun,file=fo_FullName,err=1,status='unknown',form='FORMATTED',iostat=fo_error,access=access,useropen=UOPEN) 
      call Write_LogFile('')
  2   fo_MessEr=''
      fo_Logging=Lun   ! permit logging
      if(name(1:1).ne.'+') write(Lun,*,err=1) 'Start logging...'
      if(name(1:1).eq.'+') write(Lun,*,err=1) 'Next logging...'
      if(fo_HomePath.ne.'') goto 1
      inquire(unit=Lun,name=file) ! full path request
      Call fo_SplitFileName(file) ! to get HomePath
      fo_HomePath=fo_FilePath
  1   continue
      call cf_NewUnit(Lun) 
      Return
      End Subroutine Open_LogFile

      Subroutine Open_NameFile(Lun,name) !  
      Use WHandle_Support
      Character*(*) name
      Character*256 name1,suffix
      Integer*4 Lun
	  Character*4 sts
	  Data sts/'.NAM'/                        ! standard NameFile Suffix
!   ---------------
      suffix=sts
      if(suffix.eq.fo_NameSuffix) fo_NameSuffix=''
      name1=name                              ! at first - Name as is, without any suffix     
      goto 1                                  ! then use standard suffix, then auxiliary
   2  if(Suffix.eq.'') goto 11                ! without next attempt
      fo_MessEr=Trim(fo_MessEr)//'    Try to use suffix '//Trim(Suffix)//' ...'
      call Write_LogFile('')
      Name1=Trim(Name)//Suffix
      if(suffix.ne.sts) suffix=''
      if(suffix.eq.sts) suffix=fo_NameSuffix
   1  Call fo_SplitFileName(name1)
      if(fo_error.ne.0) return                ! message done yet
      if((fo_FilePath.eq.''.or.fo_FilePath(2:2).ne.':').and.fo_HomePath.ne.' ') then
        fo_FullName=Trim(fo_HomePath)//'\'//name1  ! add HomePath to relative FileName 
      endif
      fo_MessEr='Cannot open NameFile '//fo_FullName
      open(Lun,file=fo_FullName,err=2,status='OLD',form='FORMATTED',iostat=fo_error,action='READ',useropen=UOPEN) 
      if(Lun.gt.0.and.Lun.lt.1000) cf_FHandle(Lun) = fHandle  ! remember for WriteStringByHandle
      fo_MessEr=''
      if(Lun.gt.0.and.Lun.lt.1000) then 
        cf_FHandle(Lun) = fHandle  ! remember for WriteStringByHandle
        cf_RecCnt(Lun) = 1         ! Unit got active
      endif
      inquire(unit=Lun,name=name1) ! full path request
      Call fo_SplitFileName(name1) ! to get HomePath
      fo_HomePath=fo_FilePath
  11  if(fo_Error.ne.0) call Write_LogFile('')
      call cf_NewUnit(Lun) 
      Return
      End Subroutine Open_NameFile

      Subroutine Open_File(Lun,file1,status,form) !  if FileName starts with "+" open as "APPEND" !!! 
      Use WHandle_Support
      integer*4 Lun,irecl,i,n
      character*(*) file1,status,form
      character*16 access,action,ff
	  character*256 file
!
      file=file1
      access='sequential'
      if(file(1:1).eq.'+') then
        file=file(2:256)
        access='APPEND'
      endif
!
      Call fo_SplitFileName(file)
      if(fo_error.ne.0) return                ! message done yet
      action='readwrite'
      if(status(1:1).eq.'o' .or. status(1:1).eq.'O') action='read'  ! "OLD" status
      ff=form
      if((ff(1:1).eq.'u'.or.ff(1:1).eq.'U').and.fo_BinarExt.ne.'') then 
      do i=1,12
        if(fo_FileExt(2:4).eq.fo_BinarExt(3*i-2:3*i)) ff='BINARY'  ! "Binary" instead of "UnFormatted"
      enddo
      endif
      fo_MessEr=' Unit XXXX: open as '//Trim(status)//' '//Trim(ff)//' '//Trim(action)//' file '//Trim(file1)
      write(fo_MessEr(7:10),'(i4)',err=1) Lun
  1   call Write_LogFile('')                            ! inform user what is doing
      n=2                                               ! 1: as given, 2: in NameFile directory
	  if(fo_HomePath.eq.' ') n=1                        ! not known:no 2-nd attempt 
      if((fo_FilePath.eq.''.or.fo_FilePath(2:2).ne.':').and.n.ne.1) then
        fo_FullName=Trim(fo_HomePath)//'\'//file                          ! add HomePath to relative FileName 
        if(fo_NamePrefix.ne.' ') fo_FullName=Trim(fo_NamePrefix)//file    ! add given Prefix to relative FileName 
        n=1                                                               ! and no 2-nd attempt
      endif
      fo_Error=2
      fo_MessEr='Cannot open file '//fo_FullName
      fHandle=0
      if(status(1:1).eq.'s'.or.status(1:1).eq.'S') then                 ! SCRATCH
        fo_FullName='SCRATCH'
        open(Lun,status='SCRATCH',err=99,form=ff,iostat=fo_Error)
      else
	    goto 4                                                          ! 1-st attempt
   2    n=n-1
        if(n.eq.0) goto 99               
        fo_MessEr=Trim(fo_MessEr)//'    Try to find in '//Trim(fo_HomePath)//' ...'
        call Write_LogFile('')
        fo_FullName=Trim(fo_HomePath)//'\'//fo_FileName
        if(fo_FileExt(1:1).eq.'.') fo_FullName=Trim(fo_FullName)//fo_FileExt
        fo_MessEr='Cannot open file '//Trim(fo_FullName)//'   It was the final attempt!'
   4    if(ff(1:1).eq.'d' .or. ff(1:1).eq.'D')       then               ! Dnnnnnn  - direct access file
          read(ff(2:7),'(i6)',err=99) irecl
          open(Lun,file=fo_FullName,err=2,status=status,access='DIRECT',recl=irecl,iostat=fo_error,action=action)
        else
          open(Lun,file=fo_FullName,err=2,status=status,form=ff,iostat=fo_Error,action=action,access=access,useropen=UOPEN)
        endif
      endif
   9  fo_Error=0
      fo_MessEr=''
      call Write_LogFile('file '//Trim(fo_FullName)//' opened successfully') 
      if(Lun.gt.0.and.Lun.lt.1000) cf_FHandle(Lun) = fHandle  ! remember for WriteStringByHandle
  99  if(fo_Error.ne.0) call Write_LogFile('')
      call cf_NewUnit(Lun) 
      End Subroutine Open_File

      Subroutine Close_File(Lun)    ! and delete file if Lun<0
      integer*4 Lun,Luna
      Luna=iabs(Lun)
      if(Lun.gt.0) Close(Lun) 
      if(Lun.lt.0) Close(Luna,Status='delete') 
      if(Luna.gt.0.and.Luna.le.1000) then 
        cf_FHandle(Luna) = 0
        cf_RecCnt(Luna) = 0         ! Unit got inactive
      endif
      End Subroutine Close_File

!
!  Problem with standalone collected DLL's: we can't pass logical unit numbers as parameters
!  while calling one DLL from another!  We have pass WinHandles instead!
!  F2F convertor takes it to account if directive   !F2F:HandleDriven=[ unit list ]  present
!
      Subroutine WriteStringByHandle(h,str)
      character *(*) str
      integer *4 h,n1,n2
!  STR may contain spec-chars (250) due to imitation "/" in formats !!!   Split.
        n2=0
        n1=1
        if(str(1:1).eq.' ') n1=2       ! maybe 1-st blank put by Fortran ! 
        do i=1,Len_Trim(str)
          if(str(i:i).eq.Char(250)) then    
            if(n1.le.n2) call WriteLineByHandle(h, str(n1:n2)) 
            n1=i+1
          endif
          if(str(i:i).ne.' ' ) n2=i 
        enddo
        if(n1.le.n2) call WriteLineByHandle(h, str(n1:n2))  ! last non-empty string
        return
	  end Subroutine WriteStringByHandle

      Subroutine WriteLineByHandle(h,str)
      character *(*) str
      integer *4 h
!DEC$ ATTRIBUTES C,REFERENCE, ALIAS: '_Write_String' :: Write_String
      if(h.lt.0) then      
          call Write_String(-h, str, ires)      ! using Windows-Handle
      else
          write(h,*,err=1) trim(str)            ! using logical unit number
      endif
   1  return
      End Subroutine WriteLineByHandle

!
!  Problem with standalone collected DLL's: modules Long_Jump and ComFort do not contain
!  actual information!  They prooved to be loaded twice in two different areas of common
!  virtual memory space!   We need duplicate it from Pivot DLL  to auxiliary DLL.
!  
      Subroutine StandaloneDLL(name,ibuf)
	  Use Long_Jump
      Character*16 name
	  Integer*4 ibuf(1030)
	  data MagNum/142857/
!DEC$ IF DEFINED (PIVOT)
      ibuf(1)=MagNum               ! Magic number
      ibuf(2)=cf_OldLinkArea(2)    ! own Handle (passed by old P_Client)
      ibuf(3)=cf_MainHandle        ! Client Handle (always needed)
      ibuf(4)=cf_ConsoleStatus
      do i=1,20
	    ibuf(i+10)=jmp_buf(i) 
      enddo
      do i=1,1000
	    ibuf(i+30)=cf_RecCnt(i) 
      enddo
!DEC$ ELSE
      if(ibuf(1).ne.MagNum) return
      cf_MainHandle=ibuf(3)
      cf_ConsoleStatus=ibuf(4)
	  if(cf_ConsoleStatus.eq.1) then    ! settings for old P_Client:
	    cf_OldLinkArea(1)=cf_ConsoleStatus
	    cf_OldLinkArea(2)=ibuf(2)
	    cf_OldLinkArea(3)=cf_MainHandle
	    cf_OldLinkArea(5)=4000
	    cf_OldLinkArea(36)=1099
	  endif
      do i=1,20
	    jmp_buf(i) = ibuf(i+10)
      enddo
      do i=1,1000
	    cf_RecCnt(i) = ibuf(i+30)
      enddo
      cf_DLLName = name
!DEC$ ENDIF
      return
      End Subroutine StandaloneDLL


End Module ComFort

