unit Convertor;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, ExtCtrls, ComCtrls, StdCtrls, ShellAPI, ShlObj, Math;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    mnuStartt: TMenuItem;
    mnuOption: TMenuItem;
    mnuHelp: TMenuItem;
    mnuClose: TMenuItem;
    StatusBar1: TStatusBar;
    Memo1: TMemo;
    Panel0: TPanel;
    Panel1: TPanel;
    Panel2: TPanel;
    ListBox1: TListBox;
    ListBox2: TListBox;
    mnuConsoles: TMenuItem;
    mnuInsertSave: TMenuItem;
    mnuInsertTrace: TMenuItem;
    mnuName: TMenuItem;
    RedirectRead1: TMenuItem;
    RedirectWrite1: TMenuItem;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    mnuCreateProject: TMenuItem;
    mnuSingleSource: TMenuItem;
    WholeProject1: TMenuItem;
    ConsoleApplication1: TMenuItem;
    procedure mnuCloseClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure mnuStarttClick(Sender: TObject);
    procedure mnuHelpClick(Sender: TObject);
    procedure mnuConsolesClick(Sender: TObject);
    procedure CheckedItemClick(Sender: TObject);
    procedure RedirectClick(Sender: TObject);
    procedure mnuNameClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure WholeProject1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    Procedure F2F(Sender:TObject);
    Procedure GenPro(PrName:string);
  end;

var
  Form1: TForm1;
  Params:array[1..20] of string;
  Silent:boolean;
  WholeProject:boolean;
  MPI:boolean=false;
Var List:TStringList=nil; LastFile:string;

implementation

{$R *.DFM}

Const OwnMark = 'F2F : Fortran to Fortran Convertor. Vers:25/12/2004.';
      BlockConvert = '!F2F:NO_TOUCH!';
      PermitConvert = '!F2F:TOUCH!';
Const Comm='  !  F2F'; //'  !  WHI';     { comment for marking }
      cr=#13;                            { ord(cr) must be < ord(' ') !!! }
      lf=#10;
Const ConsoleApplication:boolean = false;

Type TFortran = (WatCom,Compaq);
     TSourceStack = record               { Source Stack : }
       fn:string;                        { file name      }
       fh:text;                          { file handle    }
     end;

Var   CompilerName:string = 'Compaq';    {  - default            }
      Fortran:TFortran = Compaq;         { Fortran Compiler type }
      Directly:array[0..1] of boolean = (true,true);    { Direct I/O through Common/Link_Area/... or buffered to INP/OUT }
      RedirUnits:array[0..1] of string[4] = ('91','92');{ where to redirect }
      ErrLab:string='9470';              { Label for jump if I/O error }
      Console:string=',*,5,6,DEBUG,';    { List of redirected units }
      flSave:boolean=true;               { Insert "Save" in each subroutine }
      fconv:boolean=true;                { Change / to 1H\ in formats }
      ftrace:boolean=false;              { CALLs trace }
      FreeForm:boolean=false;            { free form needed (F90) }
      Headers_Inline:boolean=true;       { permits Header inlining }
      ownfment:boolean=false;            { Entry Free_Memory presents }
      HeadName:string='';                { Name of Main Program }
      pseudo:integer=0;
      CharVars:TStringList=nil;

Var f2:text;                             { output file handle }
    s,s1,NextLine,RestLine,routine,Target,HandleDriven:string;
    LastChar,LastCharP,LastCharR:char;
    i,j,k,nc,jfl,stat,LPos,kfop,loops,lb:integer;
    Pivot,lbText:string[6];
    errl,retfl,finish,quote,fprogram:boolean;
    CurFormat:string;
    formal:array[1..1000] of string[6];
    loopstack:array[1..100] of integer;
    lmform,QuotaCnt:integer;
    mform:array[0..20] of string[80];
    parm1,AllNonBlan,SourceFileName,Macros,OwnMacro:string;
    CurMacro:array[1..9] of string;
    decl:boolean;                         { declarative part of routine }
    SourceStack:array[0..10] of TSourceStack;
    CurSource:integer;
    Source2:text;   // file for source with Compaq cond_directives
    Mout1,Mout2,Mout3,keepSource2:boolean;
    SourceCnt,DestCnt:integer;
var BlockConvertFile,BlockConvertRoutine,BlockConvertLine:boolean;

// ----------------------------- F2F --------------------------------

Procedure Mess(s:string);
begin
  Form1.StatusBar1.SimpleText:=SourceStack[0].fn+'    Input Lines:'+IntToStr(SourceCnt)+'     Output Lines:'+IntToStr(DestCnt)+'    '+s;
end;

Procedure GetNextLine;
begin
  if RestLine<>'' then begin NextLine:=RestLine; RestLine:=''; Exit; end;
  if CurSource=0 then Inc(SourceCnt);
  ReadLn(SourceStack[CurSource].fh,NextLine);
  if (CurSource=0) and not WholeProject then Form1.ListBox1.Items.Add(NextLine);
end;

Function IsComment(s:string):boolean;
var i:integer;
begin IsComment:=true;
  if (s='') or (s[1]='C') or (s[1]='c') then Exit;
  if s[1]='*' then begin IsComment:=(s[2]<>'$'); Exit; end;
  if s[1]='!' then begin IsComment:=(s[2]<>'D'); Exit; end;
  for i:=2 to Length(s) do
    if s[i]<>' ' then begin IsComment:=(s[i]='!'); Exit; end;
end;

Procedure Out(s:string);
begin
  if not Mout1 then Exit;
  if (s<>'') and (s[1]='C') then
    if AnsiUpperCase(TrimRight(s))<>'CONTAINS' then s[1]:='!';     // F90 needs "!" as comment flag!
  WriteLn(f2,s);
  Inc(DestCnt);
  if not WholeProject then Form1.ListBox2.Items.Add(s);
end;

Procedure Out_FF(s1,s2:string);
begin   if FreeForm or (Length(s1+s2)<73) then Out(s1+s2)  else
   begin Out(s1); Out('     * '+s2);  end;
end;

Procedure Redirect(k:integer);
begin
  Directly[k] := ( (s='') or (s='0') );    { default }
  RedirUnits[k]:=s;
end;

Function RedirFun(k:integer):string;
begin
  if Directly[k] then Case k of
     0 : begin RedirFun:='      Read(cf_BufIO,';  Exit; end;
     1 : begin RedirFun:='      Write(cf_BufIO,'; Exit; end;
  end;
  Out('      Call cf_NewRecord('+RedirUnits[k]+')       !  - redirected !');
  Case k of
     0 : RedirFun:='      Read('+RedirUnits[0]+',';
     1 : RedirFun:='      Write('+RedirUnits[1]+',';
  end;
end;

Function GetC:Char;
begin Inc(nc); if quote then begin if nc>Length(s) then GetC:=cr else GetC:=s[nc]; Exit; end;
  While (nc<Length(s)) and (s[nc]=' ') do Inc(nc);
  if nc>Length(s) then GetC:=cr else
  if (Ord(s[nc])>=Ord('a')) and (Ord(s[nc])<=Ord('z'))          { UpperCase }
    then GetC:=Chr(Ord(s[nc])-Ord('a')+Ord('A')) else GetC:=s[nc];
end;

Function GetIdent:string;
Var c:char; r:string;
begin  r:='';
  Repeat c:=GetC; until (c in ['A'..'Z']) or (c='_') or (c=cr);
  While c in ['A'..'Z','_','0'..'9'] do begin r:=r+c; c:=GetC; end;
  GetIdent:=r; LastCharR:=c;
end;

Function NextIsBlank:boolean;
begin NextIsBlank:=true;
  if nc+1 > Length(s) then Exit;
  if (s[nc+1]<>' ') and (s[nc+1]<>'(') then NextIsBlank:=false;
end;

Function Present(image:string):boolean;   { image must be in UpperCase! }
var i,k:integer;
begin Present:=false;  AllNonBlan:='';
  if IsComment(s) then Exit;
  if FreeForm then k:=1 else k:=7;
  for i:=k to Length(s) do
    if s[i]<>' ' then begin AllNonBlan:=AllNonBlan+UpCase(s[i]); if(AllNonBlan[1]<>image[1]) then Exit; end;
  if Length(AllNonBlan)<Length(image) then Exit;
  Present:=(Pos(image,AllNonBlan)=1);
end;

Function PresentAnywhere(image:string):boolean;
var i,k:integer;
begin PresentAnywhere:=false;  AllNonBlan:='';
  if IsComment(s) then Exit;
  if FreeForm then k:=1 else k:=7;
  for i:=k to Length(s) do if s[i]<>' ' then AllNonBlan:=AllNonBlan+UpCase(s[i]);
  if Length(AllNonBlan)<Length(image) then Exit;
  PresentAnywhere:=(Pos(image,AllNonBlan)>0);
end;


Function Slash(s:string):integer;
var outside:boolean; i:integer;
begin outside:=true; Slash:=0;
  for i:=1 to Length(s) do
    if s[i]='''' then outside:=not outside else
      if (s[i]='/') and outside then begin Slash:=i; Break; end;
end;

Function Continued:boolean;
begin
  if LastChar='&' then Continued:=true  else   { AMG }
  Continued:=(not FreeForm and (Length(NextLine)>5) and (NextLine[6]<>' ') and (NextLine[1]=' '));
end;

Function Continuation:boolean;
begin
  if LastCharP='&' then Continuation:=true  else
  Continuation:=(not FreeForm and (Length(s)>5) and (s[6]<>' ') and (s[1]=' '));
end;

Procedure GetLine1;
var ss,sss:string;
    c1:char; i,k:integer; b,q:boolean;
Procedure Out_S2(s:string);
begin
  if ((CurSource<1) and (Pos('!>>>>>>',s)<>1)) and WholeProject and not b then WriteLn(Source2,s);
end;

begin  b:=false; sss:=NextLine;  Mout1:=Mout2;         { usual result }
  Repeat if Eof(SourceStack[CurSource].fh) then
    begin  CloseFile(SourceStack[CurSource].fh);  b:=(CurSource>0);
      NextLine:='!>>>>>>      end of   '+SourceStack[CurSource].fn;
      Dec(CurSource);  finish:=(CurSource<0);
      if not finish and not Headers_Inline then GetNextLine;
    end else GetNextLine;
    NextLine:=NextLine+'      '; nc:=0; ss:='';
    q:=IsComment(NextLine); if not q then QuotaCnt:=0;
    for i:=1 to Length(NextLine) do Case NextLine[i] of
      '''': begin Inc(QuotaCnt); ss:=ss+''''; end;
      '"' : if not q and ((QuotaCnt mod 2)=0) then ss:=ss+'''' else ss:=ss+'"';  { change " to ' }
//       #9 : Repeat ss:=ss+' ' Until (Length(ss) mod 6)=0;            { expand TAB }
       #9 : Repeat ss:=ss+' ' Until Length(ss) > 6;   { expand TAB in the beginning}
       lf : begin ShowMessage('Cannot convert UNIX-style text!'); Halt; end;
      '!' : begin ss:=ss+'!'; if (QuotaCnt mod 2)=0 then q:=true; end;
      ';' : if not FreeForm or q or ((QuotaCnt mod 2)<>0) then ss:=ss+';' else
            begin RestLine:=NextLine; Delete(RestLine,1,i); RestLine:=Trim(RestLine);
              NextLine:=ss; Break;
            end;
      else ss:=ss+NextLine[i];
    end;
    While(Length(ss)>0) and (ss[Length(SS)]=' ') do Delete(ss,Length(SS),1);
   Until ss<>'';
   s:=ss;  Mout2:=(CurSource=0) or Headers_Inline;     { Next Line }
   if Present('INCLUDE') then
     if Present('INCLUDE''COMFORT.H''') then ss:='!' else    //  to not duplicate
   begin c1:=''''; if Pos(c1,s)=0 then c1:='"';
     i:=Pos(c1,s); k:=Pos(c1,Copy(s,i+1,255));
     if CurSource=0 then begin Out_S2(sss); Out_S2(s); end;
     if (k>1) and (CurSource<10) then
     begin s:=Copy(s,i+1,k-1);    { file name }
           if ExtractFileDir(s)='' then s:=ExtractFileDir(SourceStack[CurSource].fn)+'\'+s; //!!!!!
           SourceStack[CurSource+1].fn:=s;
     {$I-} AssignFile(SourceStack[CurSource+1].fh,SourceStack[CurSource+1].fn);
           Reset(SourceStack[CurSource+1].fh);
     {$I+} if IOResult=0 then
           begin ss:=''; if Headers_Inline then ss:='!<<<<<<';
             Inc(CurSource); ss:=ss+'      INCLUDE '+s;
           end;
     end;
   end;
    s:=sss; NextLine:=ss; quote:=false; lb:=0; c1:='0'; lbText:='      '; i:=1;
    Repeat lb:=10*lb+Ord(c1)-Ord('0'); lbText[i]:=c1; Inc(i); c1:=GetC; Until not((nc<6) and (c1 in ['0'..'9']));
    nc:=0;  lbText[1]:=' '; if (s<>'') and (s[1]='*') and (s[2]='$') then
    begin ss:=GetC+GetC+GetC+GetC;
      if ss='*$IF' then
      begin KeepSource2:=true; i:=Pos(' ',s);
        if i>0 then
        begin sss:=Copy(s,1,i); Delete(s,1,i);
          While (s<>'') and (s[1]=' ') do Delete(s,1,1);
          While (s<>'') and (s[Length(s)]=' ') do Delete(s,Length(s),1);
          While s[1]='_' do Delete(s,1,1);
          While s[Length(s)]='_' do Delete(s,Length(s),1);
          s:=sss+'__'+s+'__';  { specially for SYS: always put __ to left&right }
        end;
      end;
      if Fortran=Compaq then  { change Compiler Directives format }
      begin ss:=ss+GetC+GetC;
        if ss='*$ENDI' then s:='!DEC$ ENDIF' else
        if ss='*$ELSE' then s:='!DEC$ ELSE' else
        if (ss='*$IFDE') or (ss='*$IFND') then
        begin Delete(s,1,Pos(' ',s)); While (s<>'') and (s[1]=' ') do Delete(s,1,1);
          i:=Pos(' ',s); if i>0 then s:=Copy(s,1,i-1);
          s:='!DEC$ IF DEFINED ('+s+')';
          if ss='*$IFND' then
          begin Out(s); Out_S2(s);
            s:='!DEC$ ELSE'; Inc(pseudo);
          end;
        end
      end;
      nc:=0;
    end;
  i:=Length(s); While (i>0) and (s[i]=' ') do Dec(i);
  LastCharP:=LastChar; if i=0 then LastChar:=' ' else LastChar:=s[i];
  if LastChar='&' then  if not IsComment(s) then FreeForm:=true;
  if s='!DEC$ ENDIF' then Dec(pseudo);
  if Pos('!DEC$ IF DEFINED',s)=1 then
  begin Inc(pseudo); CurMacro[pseudo]:='';
    i:=Pos('(',s); k:=Pos(')',s); if i<k then CurMacro[pseudo]:=Trim(Copy(s,i+1,k-i-1));
  end;
  if (Pos('!DEC$ ELSE',s)=1) and (pseudo>0) then CurMacro[pseudo]:='-'+CurMacro[pseudo];
  Out_S2(s);       // write Source with corrected Cond.Dirs from WatCom to Compaq
  if finish and WholeProject then
  begin
     try
       CloseFile(Source2); if not KeepSource2 then Erase(Source2);
     finally
     end;
  end;
end;

Function Refused:boolean;
var c:string;
begin Result:=false; if pseudo<1 then Exit;
  c:=CurMacro[pseudo]; if c='' then Exit;
  if c[1]='-' then Result:=(Pos(Copy(c,2,100),Macros)>0) else Result:=(Pos(c,Macros)=0);
end;

Procedure GetLine;
begin
  GetLine1;
  if Pos('!F2F:CONSOLE',s)=1 then Console:=',*,5,6,DEBUG,'+AnsiUpperCase(Trim(Copy(s,14,255)))+',';
  if Pos('!F2F:HANDLEDRIVEN',s)=1 then HandleDriven:=','+AnsiUpperCase(Trim(Copy(s,19,255)))+',';
  if Pos('!F2F:OWNMACRO',s)=1 then OwnMacro:=' '+AnsiUpperCase(Trim(Copy(s,15,255)))+' ';
  if not Present('INTERFACE') then Exit;
  Repeat Out(s); GetLine1;
  Until Present('ENDINTERFACE') or (AllNonBlan='END');
  Out(s); GetLine;
end;

Procedure GetFullLine;
var s1:string; i,k:integer;
begin  s1:=s; k:=nc; if not Continued then Exit;
  While Continued do
  begin  if FreeForm
    then begin i:=Pos('&',s); s1:=Copy(s,1,i-1)+NextLine; end
    else begin s1:=s1+Copy(NextLine,7,255); end;
    GetLine;
  end;
  s:=s1;  nc:=k;
end;


Function CharDef:boolean;
var s1:string;
begin CharDef:=false;
{  if not decl then Exit;  AMG !!!  }
  if not Present('CHARACTER') then Exit;
  s1:=s; While Continued do
    begin s1:=s1+' '+Copy(NextLine,7,255); Out(s); GetLine; end;
  Out(s); s:=s1; nc:=10; While (nc<Length(s)) and (s[nc]<>' ') do Inc(nc);
  Repeat s1:=GetIdent;
    if s1<>'' then if CharVars.IndexOf(s1)<0 then CharVars.Add(s1);
  Until LastCharR=cr;
  CharDef:=true;
end;

Function Tail:boolean;
var id:string; c:char;
begin nc:=0;
  quote:=false; id:=''; c:=GetC;
  Tail:=false; if c<>'E' then Exit;
  While c in ['A'..'Z','_','0'..'9'] do begin id:=id+c; c:=GetC; end;
  Tail:=((id='END') or (Copy(id,1,11)='ENDFUNCTION')
                    or (Copy(id,1,13)='ENDSUBROUTINE'));
end;

Function Head:boolean;
var c1:Char;
  c:string;
begin nc:=0; c:=GetC; Head:=false;
  if Pos(c,'PSFRILCD')=0 then Exit;
  While nc<=Length(s) do
  begin c1:=GetC; if c1='*' then Repeat c1:=GetC Until not (c1 in ['0'..'9']);
    c:=c+c1;
    if Pos(c,'SUBROUTINE')=1        then if Length(c)<10 then continue else Break;
    if Pos(c,'FUNCTION')=1          then if Length(c)<8  then continue else Break;
    if Pos(c,'DOUBLEPRECISIONFUNCTION')=1 then if Length(c)<23 then continue else Break;
    if Pos(c,'REALFUNCTION')=1      then if Length(c)<12 then continue else Break;
    if Pos(c,'INTEGERFUNCTION')=1   then if Length(c)<15 then continue else Break;
    if Pos(c,'LOGICALFUNCTION')=1   then if Length(c)<15 then continue else Break;
    if Pos(c,'CHARACTERFUNCTION')=1 then if Length(c)<17 then continue else Break;
    if Pos(c,'COMPLEXFUNCTION')=1   then if Length(c)<15 then continue else Break;
    if Pos(c,'PROGRAM')=1           then if Length(c)<7 then continue else
      begin  fProgram:=true;  Head:=true;
        s:='      SUBROUTINE DLL_MAIN               '+Comm+' : instead of PROGRAM';
      end;
    Exit;
  end;
  Routine:=''; c1:=' '; Repeat Routine:=Routine+c1; c1:=GetC; Until Ord(c1)<Ord('0');
  loops:=0; Delete(Routine,1,1);  Head:=true;
end;

procedure floops;
begin if (loops>0) and (loopstack[loops]=lb) then Dec(loops); end;

Procedure ChIO;
var c,ff,LUN,id_LUN,LUNT,c15:string; c1,c2:char;
   i,j,jj,it:integer;
   mif,found,lastcomma,ExternalIO:boolean;
   jumper:string;
   MPIflg:boolean;

Procedure STLUN;             // Open/Read/Write:  get LUN, MPIflg, ExternalIO
var ii,nbr:integer;
begin nbr:=0; LPos:=0; LUN:=''; c1:=GetC;  id_LUN:='0';
  LUNT:='      Call cf_NewRecord(0)';  ExternalIO:=true;
  MPIflg:=MPI;  if c1=cr then begin Out(' WARNING !!! '); Exit; end;
  Repeat
    if c1<>' ' then LUN:=LUN+c1;
    LPos:=nc; c1:=GetC;
    if c1='(' then Inc(nbr);
    if c1=')' then Dec(nbr);
  Until ((c1=',') and (nbr=0)) or (c1=cr) or (nbr<0);
  if Copy(Lun,1,5)='UNIT=' then Delete(Lun,1,5);
  ii:=0; While (ii<Length(LUN)) and (LUN[ii+1] in ['A'..'Z','_','0'..'9','*']) do Inc(ii);
  LUNT:=Copy(LUN,1,ii);  { only variable name without possible index }
  id_LUN:=LUN; if (CharVars.IndexOf(LUNT)>=0) or (Pos('OUTSTR',LUNT)=1) then
    begin id_LUN:='0'; MPIflg:=false; ExternalIO:=false; end;  // internal I/O !!!
  if (LUNT='*') or (LUNT='DEBUG') then id_LUN:='0';
  LUNT:=','+LUNT+','; LPos:=Pos(LUNT,HandleDriven)+Pos(LUNT,Console);   //  Lpos>0   -  console I/O
  LUNT:='      Call cf_NewRecord('+id_LUN+')';
end;

Function GetKeyValue(Key:string):string;    //  PresentAnyWhere must be just done !!!
var c:char; brcnt:integer;                  //  because AllNonBlan used instead of S
    nc:integer;
begin Result:='';  nc:=Pos(Key+'=',AllNonBlan); if nc=0 then Exit;
  nc:=nc+Length(Key);  brcnt:=0;
  While nc<Length(AllNonBlan) do
    begin Inc(nc); c:=AllNonBlan[nc];
      if c='(' then Inc(brcnt);  if c=')' then Dec(brcnt);
      if (c=',') or ((c=')') and (brcnt<0)) or (c='!') then Break else Result:=Result+c;
    end;
  if Pos('(',Result)>Pos(')',Result) then Result:=Result+')';
end;

Procedure Conv_Op;
var fn,fs,ff,fios,fapp,er,frecl:string;
begin  GetFullLine;
  StLUN;
  if not PresentAnyWhere('OPEN(') then  Out('WARNING! Maybe this line must stay AS IS !!');
  ff:=GetKeyValue('FORM');    if ff='' then ff:='''formatted''';
  frecl:=GetKeyValue('RECL'); if frecl<>'' then
  begin   //  Direct access:  FORM=Dnnnnnn  !!!
    ff:='cf_EBuf(201:207)';
    s:='      Write('+ff+',''(1HD,i6)'',err='+ERRLAB+') '+frecl;
    Out(s);
  end;
  fios:=GetKeyValue('IOSTAT');
  fapp:=GetKeyValue('POSITION'); if fapp='' then fapp:=GetKeyValue('ACCESS');
  fn:=GetKeyValue('FILE');    if fn='' then fn:='''''';
  fs:=GetKeyValue('STATUS');  if fs='' then fs:='''unknown''';
  er:=GetKeyValue('ERR');     if er='' then begin er:=ERRLAB; errl:=true; end;
  if fapp='''APPEND''' then fn:='''+''//'+fn;
  s:='      CALL Open_File('+Trim(LUN)+','+fn+',';  Out_FF(s,fs+','+ff+')');
  s:='      if(fo_Error.ne.0) goto '+er;
  if fios<>'' then s:='      '+fios+'=fo_Error';
end;

Procedure GetFormat;   { Produces ff & c1 & CurFormat}
var e:boolean; nbr:integer;
begin ff:=''; CurFormat:=''; if c1=')' then Exit;
  c1:=' '; quote:=false; e:=false; nbr:=0;
  Repeat ff:=ff+c1; c1:=GetC;  if Ord(c1)<Ord('0') then
    begin if c1='(' then Inc(nbr); if c1=')' then Dec(nbr);
      if c1='''' then quote:=not quote else if c1<>'*' then e:=not quote;
      if e and (c1<>cr) and (c1<>',') and { (c1<>')') } (nbr>=0) then e:=false;
    end;
  Until e or (c1=cr);
  CurFormat:=Trim(ff);
  if (CurFormat<>'') and not (CurFormat[1] in ['*','''','1'..'9']) then CurFormat:='';
end;

Procedure PutFormat(k:integer);     { 1-write, 0-read }
begin errl:=true;
  While (ff<>'') and (ff[1]=' ') do Delete(ff,1,1);  if ff='' then Exit;
  if Directly[k] and (ff[1]<>'*') and (ff[1]<>'''') and (LPos>0)  then
  begin if jfl<1000 then Inc(jfl);
    Formal[jfl]:=ff;
  end;
  ff:=ff+',';
end;

Function WRS(ssss:string):boolean;
var jj,n1,n2:integer; ss,sss,s2:string;
begin WRS:=true;
  ss:=ssss; jj:=Pos(',,',ss); if jj>0 then Delete(ss,jj,1);
  jj:=nc; sss:=''; quote:=false; n2:=0;
  While nc<Length(s) do
  begin sss:=sss+GetC;
    if Pos(sss,',ERR=')<>1 then sss:='' else Case Length(sss) of
      1:n1:=nc;
      2,3,4:;
      5:break;
     end;
  end;
  if sss=',ERR=' then
  begin
  {  Repeat Until Ord(GetC)<Ord('0'); n2:=nc-n1; Delete(s,n1,n2); }
  { above - to have own err handling, next 2 lines= users handling }
    ss:=ss+' '; n1:=Pos(',ERR=',ss);  WRS:=false;
    Delete(ss,n1,5); While ss[n1] in ['0'..'9'] do Delete(ss,n1,1);
  end;
  nc:=jj;  s2:=Copy(s,nc+1,250);  s:=ss+s2;
  n1:=Pos(',)',s); if n1>0 then Delete(s,n1,1);  { kill extra Comma }
  if FreeForm or (Length(s)<=72) then Exit;
  if Length(ss)<=72 then sss:=ss else
  begin if mif then jj:=j else jj:=72;
    Out(Copy(ss,1,jj)); sss:='     -   '+Copy(ss,jj+1,100);
    if mif then sss[6]:=' ';
  end;
  s:=sss; if s2='' then Exit;
  Out(s); s:='     -   '+s2;
end;

procedure AddCommaToFormat(var s:string);
begin  While (Length(s)>6) and (s[Length(s)]=' ') do Delete(s,Length(s),1);
  if (Length(s)>6) and (s[Length(s)]<>'(') and (s[Length(s)]<>')') and (s[Length(s)]<>',') then s:=s+',';
  lastcomma:=(s[Length(s)]=',');
end;

begin  mif:=false; it:=0; nc:=6; c15:=Copy(s,1,5);
  ExternalIO:=true; LUNT:='      Call cf_NewRecord(0)';
  if FreeForm then begin nc:=0; c15:=''; end;
  if not Present('FORMAT') and not Continuation then retfl:=false;
{  - double SAVE - works!
  if flsave and (c15='     ') and Present('SAVE') then
    begin s[1]:='C'; c15[1]:='C';  s:=s+'   ! see SAVE above!'; end;
}
  Repeat c:=''; found:=false; i:=nc;
  While nc<=Length(s) do
  begin c1:=GetC; c:=c+c1; if c1='!' then Exit;
    if (c15<>'') and (c15<>'     ') and (Pos(c,'ENDDO')=1) then if Length(c)<5 then continue else
    begin  { <label> ENDDO  - typical mistake. We can correct it }
      Out(Copy(s,1,6)+'  continue  ! WHI:this label was glued to next line!');
      for j:=1 to 6 do s[j]:=' ';
    end;
    if Pos(c,'DO')=1     then if Length(c)<>2 then continue else
    begin j:=0; c2:='0'; decl:=false;
      repeat j:=10*j+ord(c2)-ord('0'); c2:=GetC; until not(c2 in ['0'..'9']);
      if (j>0) and (loops<100) then begin Inc(loops); loopstack[loops]:=j; end;
      Break;
    end;
    if Pos(c,'IF(')=1    then if Length(c)<3 then continue else begin mif:=true; decl:=false; Break; end;
    if Pos(c,'PAUSE')=1   then if Length(c)<5 then continue else
      begin s:=Copy(s,1,6)+'Continue   ! instead of PAUSE !'; decl:=false; Exit; end;
    if Pos(c,'STOP')=1   then if Length(c)<4 then continue else if NextIsBlank then
      if ((nc<Length(s)) and (Ord(s[nc+1])>=Ord('0'))) or
         ((nc>10) and (Ord(s[nc-4])>=Ord('0'))) then begin c:=''; continue; end else
    begin s:=Copy(s,1,i)+'CALL cf_Instead_of_STOP   '+Comm;  retfl:=true;
      if not FreeForm and (Length(s)>72) then
        begin Out( Copy(s,1,i)); Delete(s,1,i); s:='     - '+s; end;
      decl:=false; Exit;
    end;
    if ftrace and not mif and not Continuation then
      if Pos(c,'CALL')=1  then if Length(c)<4 then continue else if NextIsBlank then
      begin
        c:=Routine+': '+s;  if Length(c)>40 then c:=Copy(c,1,40)+' ...';
        repeat j:=Pos('''',c); if j>0 then c[j]:=' '; until j=0;
        Out(Copy(s,1,6)+'cf_BufIO=''Trace> '+c+'''');
        Out('      call cf_NewRecord(0) ');
        Out('      call Interface_IO(1)   ! Write');
        for j:=1 to 5 do s[j]:=' '; Exit;
      end;
    if Pos(c,'OPEN(')=1  then if Length(c)<>5 then continue else
      begin found:=true; it:=1; break; end;
    if Pos(c,'CLOSE(')=1  then if Length(c)<>6 then continue else
      begin found:=true; it:=2; break; end;
    if Pos(c,'READ')=1   then if Length(c)<>4 then continue else if NextIsBlank then
      begin found:=true; it:=4; break; end;
    if Pos(c,'PRINT')=1  then if Length(c)<>5 then continue else if NextIsBlank then
      begin found:=true; it:=5; break; end;
    if Pos(c,'WRITE(')=1 then if Length(c)<>6 then continue else
      begin found:=true; it:=6; break; end;
    if Pos(c,'RETURN')=1 then if Length(c)<>6 then continue else if NextIsBlank then retfl:=true;
    if fconv and (Pos(c,'FORMAT')=1) then if Length(c)<6 then continue else
      if (s[6]=' ') and not IsComment(s) then
      begin c:=''; i:=0; Repeat Inc(i) until s[i]<>' ';  { c=<Label> }
        While (i<6) and (s[i]<>' ') do begin c:=c+s[i]; Inc(i); end;
        for i:=1 to jfl do if Formal[i]=c then begin c:=' '+c; Break; end;
        if (c<>'') and (c[1]=' ') then   { format was used by spec. Read/Write }
        begin i:=0; lmform:=0;
          While Continued do begin mform[lmform]:=s; Inc(lmform); GetLine; end;
          mform[lmform]:=s;
          for j:=0 to lmform do if Slash(mform[j])>0 then Begin i:=1; Break; end;
          if i>0 then      { and "/" present in this format }
          begin  Out('C *** F2F: changed / to '''' (char(250)) !!! ');
            lastcomma:=false;
            for j:=0 to lmform do
            begin c:=mform[j]+' ';
              if lastcomma then
                for i:=7 to Length(c) do        { clear 1-st comma }
                  if c[i]=',' then c[i]:=' ' else if c[i]<>' ' then Break;
              repeat i:=Slash(c);
                if i>0 then
                begin   s:=Copy(c,1,i-1);
                  AddCommaToFormat(s);
                  if s<>'     &' then Out(s);
                  jj:=i; While c[i]='/' do Inc(i);
                  jj:=i-jj; write(f2,'     &  ',jj,'H');
                  Repeat write(f2,''); Dec(jj); until jj=0;
                  Out('  ');
                  Repeat Dec(i); c[i]:=' '; until i=1;
                  c[6]:='&'; i:=Pos('/',c);
                end;
              until i=0;
              AddCommaToFormat(c);
              if c<>'     &' then Out(c);
            end;
            s:='C';
          end  else   for j:=1 to lmform do Out(mform[j-1]);
        end;
        c:='?????????';
      end;
    if not mif then Exit else begin c:=''; i:=nc; end;
  end;
  if found and mif and (s[i]<>' ') and (s[i]<>')') then found:=false;
  if nc>Length(s) then Break;
  Until found or not mif;
  if not found then Exit;
  if FreeForm and (Pos(';',s)>0) then
    begin Out(' WARNING !!! Could not convert line below consist of 2 separate operators !'); Exit; end;
  j:=i; decl:=false;
  if Continuation then begin mif:=true; j:=6; end;
  if mif then begin Out(Copy(s,1,j)+'  then'); for i:=1 to j do s[i]:=' '; lbText:='      '; end;
  Lpos:=0; c1:=' ';  id_Lun:='0';  MPIflg:=MPI;
  if Continued then s1:=' ...' else s1:='';
  if (loops>0) and (loopstack[loops]=lb) and (it<>2) then Out(' WARNING !!! Could not correctly convert: '+s+s1)
    else Out('!Converted: '+s+s1);
  if it<>2 then
  begin c:=lbText+'cf_Ebuf='''+Trim(SourceFileName)+'('+IntToStr(SourceCnt)+') '+routine+': ';
    for i:=1 to Length(s) do if (s[i]<>' ') and (s[i]<>'''') then c:=c+s[i];
    c:=c+s1;   if Length(c)>70 then c:=Copy(c,1,70);
    c:=c+''''; Out(c);
    for i:=1 to 6 do if s[i] in [' ','0'..'9'] then s[i]:=' ' else Break;
  end;
  Case it of
  1: Conv_Op;
  2:begin STLUN;
      if PresentAnyWhere('STATUS=''DELETE''') then c:='-' else c:='';
      s:=lbText+'CALL Close_File('+c+Trim(Lun)+')';   // may be negative "unit" !!!
    end;
  4:begin { READ ... ==> READ(91,<format>,ERR=9471),... }
      i:=nc; if GetC='(' then i:=-1 else nc:=i;
      if i<0 then STLUN else Lpos:=nc;
      c:=Trim(Copy(s,1,j)); if c<>'' then Out(c+'     Continue');    // ???
      if Directly[0] then Out(LUNT);                               // if not - RedirFun does it !!!
      if (i<0) and (LPos<1) then s1:='      READ('+Lun+',' else  s1:=RedirFun(0);
      GetFormat;
      if MPIflg then Out('      if(cf_MyProcess.eq.0) then');          // *** MPI
      if ExternalIO and
        ((MPIflg and (CurFormat<>'')) or (LPos>0)) then           // MPI : any formatted external Read
        begin MPIflg:=false;                                      //    else direct console Read
          Lpos:=1; Repeat s[Lpos]:=' '; Inc(Lpos); Until Lpos>j;  //   ("if" and BCast does ComFort.F !)
          if Directly[0] then
          begin
            Out('      CALL Interface_IO(3)   ! Read ');
            if PresentAnywhere(',END=') then jumper:=GetKeyValue('END') else jumper:='9'+ERRLAB;
            Out('      if(Ichar(cf_BufIO(1:1)).eq.0) goto '+jumper+'    ! EOF checking');
          end;
        end;
      c:=''; if (i<0) and (c1<>')') then Repeat c:=c+c1; c1:=GetC; Until (c1=cr) or (c1=')');
      PutFormat(0); if (c<>'') and (c[1]<>',') then c:=','+c;

      if PresentAnywhere(',ERR=') then jumper:='' else jumper:='ERR='+ERRLAB;
      if not PresentAnywhere(',END=') and not PresentAnywhere(',REC=') then
      begin                                     { not for direct access ! }
        if jumper<>'' then jumper:=jumper+',';
        jumper:=jumper+'END=9'+ERRLAB;
      end;
      WRS(s1+ff+jumper+c+')');
      While Continued do begin Out(s); GetLine; end;      // List of Read maybe continued!

      if MPI and (CurFormat='') then                      // unformatted Read uncompletes for MPI !
      begin Out(s); Out('      endif');
        s:='      Call MPI_BCast(..., ..., ..., 0,cf_MPIcommunicator,cf_ierr) ! - Sorry !!!';
      end;
    end;
  5:begin { PRINT <format>,... ==> WRITE(92,<format>,ERR=9471),... }
      Out(LUNT);  id_Lun:='*';
      if Directly[1] then MPIflg:=false;                               // "if" does ComFort.h !
      if MPIflg then Out('      if(cf_MyProcess.eq.0) then');          // *** MPI
      GetFormat; PutFormat(1);  if (c1=cr) or (c1=',') then c1:=' ';
      WRS(RedirFun(1)+ff+'ERR='+ERRLAB+')'+c1);
      While Continued do begin Out(s); GetLine; end;
      if Directly[1] then
        begin  Out(s);  s:='      CALL Interface_IO(1)   !  Write';  end;
    end;
  6:begin { WRITE( ... ) ==> WRITE(92,<format>,ERR=9471),... }
      STLUN;  Out(LUNT);
//      Out('      cf_BufIO='''' ');
      GetFormat;
      c:=''; if c1<>')' then Repeat c:=c+c1; c1:=GetC; Until (c1=cr) or (c1=')');
      PutFormat(1); if (c<>'') and (c[1]<>',') then c:=','+c;
      if not PresentAnywhere(',ERR=') then c:='ERR='+ERRLAB+c;
      if ExternalIO and ((MPI and (CurFormat<>'')) or ((LPos>0) and Directly[1])) then  // any MPI-formatted output
      begin  WRS(RedirFun(1)+ff+c+')');                                                 // or console Write
        Out(s);  if mif then LPos:=j else LPos:=6;
        c:=''; for i:=1 to LPos do c:=c+' ';
        While Continued do begin GetLine; Out(s); end;
        s:=c+'CALL Interface_IO(';  MPIflg:=false;                  // "if" does ComFort.f
        if LUN='DEBUG' then s:=s+'2)    ! debug message'
                       else s:=s+'1)    ! Write';
      end  else
      begin WRS('      WRITE('+Lun+','+ff+c+')');
        if MPIflg then Out('      if(cf_MyProcess.eq.0) then');          // *** MPI
        While Continued do begin Out(s); GetLine; end;
      end;
//---------  for amg1r6 :  ium,iup via WriteStringByHandle
      if Pos(id_LUN,HandleDriven)>0 then
          s:='      call WriteStringByHandle('+id_Lun+',cf_BufIO)  ! maybe handle driven';
//-----------------------------------------------------------  2 line inserted
    end;
  end;
  if MPIflg and (it>4) then begin Out(s); s:='      endif'; end;   // on the top was:      if(cf_MyProcess.eq.0) then ...
  if mif then  begin Out(s); s:='      endif';  end;
end;

Procedure TForm1.F2F(Sender:TObject);
var ii:integer; s2:string;
begin MPI:=false; if Assigned(Sender) and (Pos('MPI',(Sender as TMenuitem).Caption)>0) then MPI:=true;
  ListBox1.Clear; ListBox2.Clear; KeepSource2:=false;
  if Params[1]='GENPRO' then begin GenPro(''); Close; Exit; end;
  if (Params[1]<>'') and (Params[2]='') then
  begin if ExtractFileDir(Params[1])='' then Params[1]:=ExpandFileName(Params[1]);
    WholeProject1Click(nil); Close; Exit;
  end;
  stat:=0; i:=0; CurSource:=0; SourceCnt:=-1; DestCnt:=0; HandleDriven:=''; Console:=',*,5,6,DEBUG,';
  flSave:=mnuInsertSave.Checked; fTrace:=mnuInsertTrace.Checked;
  OpenDialog1.Filter:='Fortran Sources(*.for;*.f;*.f90)|*.for;*.f;*.f90|Special Sources(*.src;*.srt)|*.src;*.srt|Any file|*.*';
  OpenDialog1.InitialDir:=ExtractFilePath(Application.ExeName);
  Repeat Inc(i); s:=Params[i]; parm1:=s; if s='' then Break;
    k:=Pos('=',s);      //  if k=0 then k:=Pos(':',s);  // ???
    if k=0 then  { files }
    begin {$I-} Case stat of
                 0:begin
//                     if not FileExists(s) then s:=ChangeFileExt(s,'.SRC');
//                     if not FileExists(s) then s:=ChangeFileExt(s,'.SRT');
                     s2:=ChangeFileExt(s,'.SRT'); if not FileExists(s2) then s2:=ChangeFileExt(s,'.SRC');
                     if FileExists(s2) then s:=s2;     // priority : SRT|SRC|for !!!
                     if not FileExists(s) then begin ShowMessage('Cannot find file '+s); Exit; end;
                     AssignFile(SourceStack[0].fh,s);
                     Reset(SourceStack[0].fh);
                     SourceStack[0].fn:=s;
                     s2:=ChangeFileExt(s,'.WatCom'); AssignFile(Source2,s2); ReWrite(Source2);
                   end;
                 1:begin AssignFile(f2,s); Rewrite(f2); Target:=s;
                     FreeForm:=( Pos('.F90',AnsiUpperCase(s)) > 0 );
                   end;
                 else continue;
                end;
          {$I+} if IOResult<>0 then begin Mess('*** No file: '+s); Exit; end;
          Inc(stat); continue;
    end;
    s1:=Copy(s,1,k-1); Delete(s,1,k); Delete(parm1,1,k);
    While(s<>'') and (s[Length(s)]=' ') do Delete(s,Length(s),1);
    if Pos(s1,'FORTRAN')=1  then  Case s[1] of
      'W','w': begin Fortran:=WatCom; CompilerName:='WatCom'; end;
      'C','c': begin Fortran:=Compaq; CompilerName:='Compaq'; end;
      'D','d': begin Fortran:=Compaq; CompilerName:='Compaq'; end;
    end;
    if Pos(s1,'ERRLAB')=1   then   ErrLab:=s;
    if Pos(s1,'UNITS')=1    then   Console:=','+s+',';
    if Pos(s1,'HANDLEDRIVEN')=1   then   HandleDriven:=','+s+',';
    if Pos(s1,'SAVE')=1     then   flSave:=(s='Y');
    if Pos(s1,'TRACE')=1    then   ftrace:=(s='Y');
    if Pos(s1,'NAME')=1     then   HeadName:=parm1;
    if Pos(s1,'READ')=1     then   Redirect(0);
    if Pos(s1,'WRITE')=1    then   Redirect(1);
  Until false;
  if stat<2 then
  begin  Silent:=false; Visible:=true;
    if Stat=0 then With OpenDialog1 do
    begin Title:='F2F :  Select Source file';
      Repeat if not Execute then Exit;
        FileName:=AnsiUpperCase(FileName); s:=FileName; Caption:=OwnMark+'   '+s;
        if Pos('\CONVERTED_',FileName)=0 then Break;
        ShowMessage(s+'  is converted yet !'); InitialDir:=ExtractFilePath(ExtractFileDir(FileName)); FileName:='';
      Until false;
      try
        AssignFile(SourceStack[0].fh,s);
        Reset(SourceStack[0].fh);
        SourceStack[0].fn:=s;
        FreeForm:=( Pos('.F90',AnsiUpperCase(s)) > 0 );
      except
        Mess('*** No file: '+s); Exit;
      end;
    end;
    With SaveDialog1 do
    begin Title:='F2F :  Specify Destination file';
      Filter:=OpenDialog1.Filter;
      InitialDir:=OpenDialog1.InitialDir;
      FileName:=ChangeFileExt(SourceStack[0].fn,'.FOR');
      if FileName=SourceStack[0].fn then FileName:=ChangeFileExt(FileName,'.F');
      if not Execute then begin CloseFile(SourceStack[0].fh); Exit; end;
      FileName:=AnsiUpperCase(FileName);
      Caption:=OwnMark+'   '+SourceStack[0].fn+' -> '+FileName;
      try
        AssignFile(f2,FileName); Rewrite(f2); Target:=FileName;
      except
        Mess('*** No file: '+FileName); Exit;
      end;
    end;
{
    WriteLn(OwnMark);
    WriteLn('Usage: for2dll  <from>  <to>  [ <ParName>=<value> ... ]');
    WriteLn('       Fortran=Compaq(default) or WatCom');
    WriteLn('       ErrLab=<Label>   - where to jump on error. Default=',errlab);
    WriteLn('       Units=<consoles> - whom to redirect. Default=',Console);
    WriteLn('       Read=<LUN>       - redirect console "Read"  to unit LUN.  Default=NO');
    WriteLn('       Write=<LUN>      - redirect console "Write" to unit LUN.  Default=NO');
    WriteLn('       Save=Y/N         - insert "SAVE" in each subroutine. Default=Y');
    WriteLn('       Trace=Y/N        - trace CALLs. Default=N');
    WriteLn('       Name=<DLL name>  - main subroutine name.  Default=<native>');
    WriteLn('Example: for2dll myprog.for dll.for  N=Solver  E=999 U=*,5,INOUT');
    Halt;
}
  end;
  fProgram:=false; ownfment:=false;  Screen.Cursor:=crHourGlass;
  stat:=1; finish:=false; Mout2:=true; NextLine:='';  RestLine:='';  GetLine;
  LastChar:=' ';  Out(BlockConvert);           // to not convert once more
  SourceFileName:=ExtractFileName(SourceStack[0].fn);
  s:=PermitConvert;
  While not finish do
  begin
    if s=PermitConvert then begin BlockConvertFile:=false; BlockConvertRoutine:=false; end;
    BlockConvertLine:=(s=BlockConvert); GetLine;
    if (Routine='PROGRAM') and Present('ENTRYFREE_MEMORY') then ownfment:=true;
    if Pos('!F2F:READ=',s)=1 then begin Out(s); Delete(s,1,10); Redirect(0); Continue; end;
    if Pos('!F2F:WRITE=',s)=1 then begin Out(s); Delete(s,1,11); Redirect(1); Continue; end;
    if (stat=1) and (s=BlockConvert) then BlockConvertFile:=true;
    if BlockConvertFile or IsComment(s) or Refused or (Pos('!DEC$',s)=1) then begin Out(s); Continue;  end;
    Case stat of
      1 : begin Routine:='PROGRAM'; BlockConvertRoutine:=false;
            if Head then
            begin stat:=2; loops:=0; decl:=true;
              if fprogram then
              begin Pivot:='PIVOT '; fprogram:=false;
                if MPI then
                begin s:='      Subroutine User_Main       ! main User Routine';
                  Out('      Program MPI');
                  Out('      include ''comfort.h''');       // instead of Module ComFort !!
                  Out('      cf_DLLName=''PROGRAM''');
                  Out('      call MPI_Start');
                  Out('      call RandomInitiate(cf_MyProcess,cf_MyProcess)     ! to not forget!');
                  Out('      Call User_Main    !  Instead of Program');
                  Out('      call MPI_FINALIZE(cf_ierr)');
                end  else
                begin  if HeadName='' then mnuNameClick(nil);  HeadName:=AnsiUpperCase(HeadName);
                  if ConsoleApplication then
                  begin
                  Out('      Program '+HeadName+'         !  Console Application for Debugging');
                  Out('      use ComFort');
                  Out('      integer*4 job(10000)');
                  Out('      character*256 ProjectName');
                  Out('      Equivalence(ProjectName,job(4))');
                  Out('      job(1)=-1                    ! Console I/O regime');
                  Out('      call GetArg(1,ProjectName)   ! from command line');
                  Out('      if(Init_cf(job).eq.0) Call DLL_Main');
                  Out('      Pause');
                  end  else
                  begin
                  Out('      SUBROUTINE '+HeadName+'(job)        !  main DLL routine');
                  Out('      use ComFort');
                  Out('!DEC$   ATTRIBUTES DLLEXPORT :: '+HeadName);
                  Out('!DEC$   ATTRIBUTES ALIAS : '''+HeadName+''' :: '+HeadName);
                  Out('      integer*4 job(*)        ! parameters passed from main Thread');
                  Out('      cf_DLLName='''+HeadName+'''');
                  Out('      if(Init_cf(job).eq.0) Call DLL_Main    !  Instead of Program');
                  Out('      Return');
                  Out('      end');
                  Out('      SUBROUTINE Convertor_Signature(Mark)   !  Version of F2F convertor');
                  Out('!DEC$   ATTRIBUTES DLLEXPORT :: Convertor_Signature');
                  Out('!DEC$   ATTRIBUTES ALIAS : ''Convertor_Signature'' :: Convertor_Signature');
                  Out('      Character*80 Mark');
                  Out('      Mark='''+Trim(OwnMark)+'''');
                  Out('      Return');
                  end;
                end;
                Out('      end');
                Out('!');
              end;
              CharVars.Free;  CharVars:=TStringList.Create;
              CharVars.Add('OUTSTR');
//            CharVars.Add('EXTENDED_ERR_MSG');  CharVars.Add('FO_MESSER');
            end;
            Out(s);
          end;
  2,3,4:  begin if stat=2 then
            begin
              if BlockConvertRoutine or Continuation then begin  Out(s); Continue;  end;
              if s=BlockConvert then BlockConvertRoutine:=true;
              if not BlockConvertRoutine and not MPI then Out('      use ComFort     ! F2F');
              stat:=3; errl:=false; jfl:=0; kfop:=0;
            end;
            if stat=3 then
            begin
              if (CurSource=0) and (pseudo=0) and not Continuation and
                not Present('USE') and not Present('PARAMETER') and not Present('IMPLICIT')  then
              begin  stat:=4; Mout3:=Mout1; Mout1:=true;
                if MPI then Out('      include ''comfort.h''');  // instead of Module ComFort
                if flSave then Out('      save            ! F2F:strongly recommended!');     Mout1:=Mout3;
              end;
              if Present('USECOMFORT') then s:='!';            //  to not duplicate
//              if Present('USEF_OPEN') then s:='! '+s;        //  debug
            end;
            if Tail then
            begin stat:=1;
              if errl then
              begin s1:='';
                if not retfl then Out(     '      Return                  '+Comm);
                Out(Copy(' '+Errlab+'     ',1,6)+'CALL cf_IO_ERROR        '+Comm);
                Out(                       '      Return                  '+Comm);
                Out(Copy('9'+Errlab+'     ',1,6)+'CALL cf_Eof_Read        '+Comm);
                Out(                       '      Return                  '+Comm);
                for ii:=1 to jfl do s1:=s1+' '+Formal[ii];
                jfl:=0; if s1<>'' then Out(' ! *** see Formats:'+s1);
              end;
              if (Routine='PROGRAM') and not ownfment then
              begin Out('!');
                  Out('      Entry Free_Memory   ! needed for InsteadOfStop !');
                  Out('      Return                  '+Comm);
              end;
              Out(s);
            end  else    { not "END" }
            begin
              if CharDef then Continue;
              if not BlockConvertLine then ChIO;
              Out(s); floops;  lb:=0;
            end;
          end;
    end;  // Case stat
  end;    // Read source
  CloseFile(f2);
  if mnuCreateProject.Checked then
    begin  GenPro(Target);
      With ListBox1 do Perform(WM_VSCROLL,(Items.Count shl 16)+sb_ThumbPosition,0);
      With ListBox2 do Perform(WM_VSCROLL,(Items.Count shl 16)+sb_ThumbPosition,0);
    end;
  Mess(' - ready !');
  Screen.Cursor:=crDefault;
  if Silent and not WholeProject then Close;
end;

// ------------------------ GenPro -----------------------

function ExecuteFile(FileName, Params, DefaultDir: string): integer;
var zFileName, zParams, zDir: array[0..255] of Char;  s:string;
begin
  Result := ShellExecute(Application.MainForm.Handle, nil,
    StrPCopy(zFileName, FileName), StrPCopy(zParams, Params),
    StrPCopy(zDir, DefaultDir), SW_SHOWNORMAL);
  if Result<33 then
  begin s:=' '+IntToStr(Result)+'   '#13+'  '+FileName+'  '+Params;
    if Length(GetCurrentDir)>20 then s:=s+''#13+'      ?';
    ShowMessage(s);
  end;
end;


Var ForEx:string='for';
    DLLNAM:string='DLLNAM';
    DLLFILEVERSION:string='DLLFILEVERSION';
    DLLPRODUCTVERSION:string='DLLPRODUCTVERSION';

Procedure TForm1.GenPro(PrName:string);    // Target for single  or empty for multiple
{  GenPro Name       - building project from single Source Name.for
   Genpro @File.lst  - building project consisting a set of files
     here file.lst contains a list of Names (without extension .for or .f90 !!!)
     The Main routine must be the 1-st Name !!!
   Default extension for Fortran source file is  .for
   If line in file.lst contains ".f90"  all names listed below will have
   .f90 as default extension
   Particularly the 1-st line in List may be .F90
   2-nd and 3-d parameters may be FileVersion=... ProductVersion=...
}
Var i,j,k,Multifile:integer;
    s,prev_s,fnam,edef:string;
    project,filevers,prodvers:string;
    fin,fout:textfile;
    flist:file of char;  { because of long strings !}
    bin,bout:file;
    nr,nw:integer;
    buf:array[1..10000] of char;
    e,w,wp,rc,pris:boolean;
    extlibw,extlibd:string;
    NameList:array[0..1000] of string[18];

Function Fragment:string;
var r:string; c:char;
begin r:=''; c:=' ';
  While not Eof(flist) and (Ord(c)<=Ord(' ')) do Read(flist,c);
  if Ord(c)>Ord(' ') then
  Repeat r:=r+c; c:=' '; if not Eof(flist) then Read(flist,c);
  Until Ord(c)<=Ord(' ');
  Fragment:=r;
end;

Procedure Anons(s:string);
begin
  Form1.ListBox2.Items.Add('! ***  '+s);   // ShowMessage(s);
end;

begin extlibd:=''; extlibw:=''; i:=3;
  filevers:='';  // GetEnv('FILEVERS');
  prodvers:='';  // GetEnv('PRODVERS');
  rc:=false; wp:=false; fnam:='?';
  if PrName='' then Project:=Params[2]
    else project:=ChangeFileExt(AnsiUpperCase(ExtractFileName(PrName)),'');  // ParamStr(1);   { MUST be in UpperCase !!! }
  MultiFile:=0; if Project[1]='@' then
  begin Delete(Project,1,1);
  {$I-} AssignFile(flist,Project); Reset(flist);  {$I+}
    if IoResult<>0 then begin ShowMessage('Cannot open ProjectNameList file '+Project); Exit; end;
    repeat Inc(MultiFile);
      s:=Fragment; if (Length(s)>18) or(MultiFile>1000) then
        begin ShowMessage(s+' - too long name or too many names in list !'); Exit; end;
      NameList[MultiFile]:=s;
    Until s='';
    Project:=NameList[1];  CloseFile(flist);
    if Project[1]='.' then
      begin ForEx:=Copy(Project,2,3); for k:=2 to MultiFile do NameList[k-1]:=NameList[k];
        Dec(Multifile); Project:=NameList[1];
      end;
  end;
  for k:=1 to Length(project) do project[k]:=UpCase(Project[k]);
  if Project='' then begin ShowMessage('Usage: GenPro <Project Name> [<ext dll>]'); Exit; end;
  if Length(Project)>18 then ShowMessage('Project Name cannot be longer than 18 chars!');
  Repeat s:=ParamS[i]; Inc(i); if s='' then Break;
    j:=Pos('=',s); if j>0 then     { Vers=.... }
      begin pris:=(UpCase(s[1])='P'); Delete(s,1,j);
        if pris and (s<>'') then Prodvers:=s;
        if not pris and (s<>'') then Filevers:=s;
        Continue;
      end;
{   if extlibw<>'' then begin extlibw:=extlibw+','; extlibd:=extlibd+','; end; }
    if extlibw<>'' then begin extlibw:=extlibw+' '; extlibd:=extlibd+' '; end;
    extlibw:=extlibw+s; extlibd:=extlibd+s+'.lib';
  Until s='';
  if filevers='' then FileVers:='3.1.0.99';
  if prodvers='' then ProdVers:='2.0.0.0';
  pris:=((extlibw='console') or (extlibw='CONSOLE')); { genpro <Project> CONSOLE   - project is ready yet }
  if pris then begin ExtLibW:=''; ExtLibD:=''; end;
  {$I-} AssignFile(fin,'ETALON.PRJ'); Reset(fin);  {$I+}
  if IoResult<>0 then begin ShowMessage('No template for Project!'); Exit; end;
  While not Eof(fin) do
  begin ReadLn(fin,s); e:=false; j:=1;
    k:=Pos(DLLNAM+'.for',s); if k>0 then begin s[k+8]:=ForEx[2]; s[k+9]:=ForEx[3]; end;
    if Copy(s,2,12)='file:DLLNAM.' then wp:=( (Copy(s,14,3)='WPJ') or (Copy(s,14,3)='TGT') );
    Repeat
      i:=Pos(DLLFILEVERSION,s);
      if i>0 then begin Delete(s,i,Length(DLLFILEVERSION)); Insert(filevers,s,i); end;
      i:=Pos(DLLPRODUCTVERSION,s);
      if i>0 then begin Delete(s,i,Length(DLLPRODUCTVERSION)); Insert(prodvers,s,i); end;
      i:=Pos(DLLNAM,Copy(s,j,255)); if i=0 then Break;
      e:=true; Delete(s,i+j-1,Length(DLLNAM)); Insert(project,s,i+j-1); j:=i+Length(project);
      if ExtLibw='-' then
        begin k:=Pos('SelfKiller',s); if k>0 then s:=Copy(s,1,k-2); end;
    Until i=0;
    i:=Pos('EXTLIB',s); if i>0 then
    begin e:=true; Delete(s,i,6);
      if (ExtLibW<>'') and (ExtLibW<>'-') then
        if wp then Insert(ExtLibW,s,i) else Insert(ExtLibD,s,i);
      i:=Length(s); if (i>0) and (s[i]=',') then Delete(s,i,1);
    end;
    if (Copy(s,1,12)='# End Target') then
      for k:=2 to MultiFile do if NameList[k]<>'' then
        begin edef:=NameList[k];
              if edef[1]='.' then begin ForEx:=Copy(edef,2,3); Continue; end;
              WriteLn(fout,'# Begin Source File');
              WriteLn(fout,'SOURCE=.\'+NameList[k]+'.'+ForEx);
              WriteLn(fout,'# End Source File');
        end;
    if Copy(s,1,6)='<file:' then
       begin rc:=((Pos('.rc',s)>0) or (Pos('.RC',s)>0));
         prev_s:=''; Delete(s,1,6);
         i:=Pos('#',s); if i>0 then fnam:=Copy(s,1,i-1) else fnam:=s;
         repeat i:=Pos(' ',fnam); if i>0 then Delete(fnam,i,1); until i=0;
         if (ExtLibW='-') and (Copy(fnam,1,4)='TEST') then fnam:='?';
         if pris and not rc and (Copy(fnam,1,4)<>'TEST') then fnam:='?';
         AssignFile(fout,fnam); w:=(fnam<>'?'); if w then Rewrite(fout);
       end else
    if Copy(s,1,6)='>file:' then
       begin
         if w then
           begin WriteLn(fout, prev_s); CloseFile(fout); Anons('file  '+fnam+'   created.'); end;
         wp:=false; rc:=false; fnam:='?';
       end else
    begin
      if e and wp and (prev_s<>'') and (Length(prev_s)<3) then Str(Length(s),prev_s);
      if (prev_s<>'') and (fnam<>'?') then WriteLn(fout,prev_s);
      prev_s:=s;
    end;
  end;
  CloseFile(fin);
  if ExtLibW='-' then Exit;     { Auxiliary DLL }
  {$I-} AssignFile(bin, 'console.exe');   Reset(bin, 1);  {$I+}  { Record size = 1 }
  AssignFile(bout,Project+'.exe');        Rewrite(bout, 1);      { Record size = 1 }
  DLLNAM:='ETALONETALONETALON';
  repeat i:=18;
    BlockRead(bin, Buf, SizeOf(Buf), nr);
    While i<nr do
    begin Inc(i); w:=true;
      for j:=1 to 18 do if UpCase(Buf[j+i-19])<>DLLNAM[j] then begin w:=false; Break; end;
      if w then
      begin
        for j:=1 to 18 do Buf[j+i-19]:=Chr(0);
        for j:=1 to Length(Project) do Buf[j+i-19]:=Project[j];
        j:=i-18+Length(Project);
        Repeat Buf[j]:=Buf[i]; Buf[i]:=Chr(0); Inc(i); Inc(j); Until Buf[j-1]=Chr(0);
      end;
    end;
    BlockWrite(bout, Buf, nr,nw);
  until (nr = 0) or (nw <> nr);
  CloseFile(bin);  CloseFile(bout);  if IoResult<>0 then Exit;
  Anons('Console Application '+Project+'.exe   created.'); Anons('It uses '+Project+'.DLL');
  {$I-} AssignFile(fin, 'test.opt');  Erase(fin);       {$I+}  i:=IoResult;
  {$I-} AssignFile(fin, Project+'.dsp');   Reset(fin);  {$I+}
  {$I-} AssignFile(fout,'TEST.dsp'); Append(fout);      {$I+}  w:=false;
  if IoResult<>0 then Exit;
  While not Eof(fin) do
  begin ReadLn(fin,s);
    if Copy(s,1,14)='# Begin Source' then
    w:=true;
    if w then WriteLn(fout,s);
  end;
 CloseFile(fin); CloseFile(fout);
 Anons('Project "Test" for Console debugging completely created.');
 ExecuteFile('start.exe','/max '+Project+'.dsw','');
end;

// ------------------------ Form1 -------------------------

Procedure TForm1.FormCreate(Sender: TObject);
begin Caption:=OwnMark;
  Visible:=not Silent; if Silent then Exit;
  FormResize(Sender);
  Memo1.BringToFront;
  mnuInsertSave.Checked:=flSave; mnuInsertTrace.Checked:=fTrace;
end;

procedure TForm1.mnuCloseClick(Sender: TObject);
begin
  Close;
end;

procedure TForm1.FormResize(Sender: TObject);
begin
  Panel1.Width:=ClientWidth div 2;
end;

procedure TForm1.mnuStarttClick(Sender: TObject);
begin
  Memo1.SendToBack;  WholeProject:=false;
  F2F(Sender);
end;

procedure TForm1.WholeProject1Click(Sender: TObject);
Const LinkOpt = 'kernel32.lib user32.lib gdi32.lib winspool.lib comdlg32.lib advapi32.lib shell32.lib ole32.lib oleaut32.lib uuid.lib odbc32.lib odbccp32.lib /nologo /subsystem:console /debug /machine:I386 /pdbtype:sept';
var d,dd,p,s,pr,subdir,ss,ssu,w,CurName:string;
    added:boolean; i,j,k,Place:integer;

Function CopyFile(n1:string; n2:string):boolean;
begin  if Assigned(List) then begin List.Clear; List.Free; end;
  List:=TStringList.Create;  Result:=true; LastFile:=n2;
  try
    List.LoadFromFile(n1); List.SaveToFile(n2);
  except
    ShowMessage('Cannot find file '+n1);
    Result:=false; List.Clear; List.Free; List:=nil;
  end;
end;

begin  Memo1.BringToFront;
  ConsoleApplication:=((Sender is TMenuItem) and ((Sender as TMenuItem).Tag=1));
  OpenDialog1.Filter:='Fortran Project(*.dsp;*.dsw)|*.dsp;*.dsw';
  OpenDialog1.InitialDir:=ExtractFilePath(Application.ExeName);
  OpenDialog1.Title:='F2F :  Select Source Project';
  if Assigned(Sender) and not OpenDialog1.Execute then Exit;
  if Assigned(Sender) then p:=OpenDialog1.FileName else p:=Params[1];
  WholeProject:=true; Pivot:='';   // Pivot conditional variable will be defined if Program present!
  Place:=0; OwnMacro:='';
  pr:=ChangeFileExt(ExtractFileName(p),''); SubDir:='Converted_'+pr;  k:=0; Macros:='F2F';
  dd:=ExtractFileDir(p)+'\'; d:=dd+SubDir;  CreateDir(d);  d:=d+'\';  added:=false;
  if FileExists(d+'Resource.h') or CopyFile(dd+'Resource.h',d+'Resource.h') or CopyFile(dd+'Resource.whi',d+'Resource.h')
    then else ShowMessage('I''m afraid You stay without Resource.h Header File !!!');
  s:=ChangeFileExt(p,'.dsw'); if not CopyFile(s,d+pr+'.dsw') then Exit;
  s:=ChangeFileExt(p,'.dsp'); if not CopyFile(s,d+pr+'.dsp') then Exit;
  While k<List.Count-1 do
  begin Inc(k); ss:=List[k]; if ConsoleApplication then
    begin
      i:=Pos('Dynamic-Link Library',ss);
      if i>0 then begin Delete(ss,i,20); Insert('Console Application',ss,i); end;
      i:=Pos('0x0102',ss);  if i>0 then ss[i+5]:='3';   // 0x0103
      i:=Pos('ADD BASE LINK32',ss); if i>0 then ss:=Copy(ss,1,i+15)+LinkOpt;
      i:=Pos('ADD LINK32',ss); if i>0 then ss:=Copy(ss,1,i+10)+LinkOpt;
      i:=Pos('/dll',ss); if i>0 then Delete(ss,i,4);
    end  else
    begin j:=Pos('/dll',ss);
      i:=Pos('Console Application',ss);
      if i>0 then begin Delete(ss,i,19); Insert('Dynamic-Link Library',ss,i); end;
      i:=Pos('0x0103',ss);  if i>0 then ss[i+5]:='2';   // 0x0102
      if Pos('# PROP BASE Output_Dir',ss)=1 then ss:='# PROP BASE Output_Dir ""';
      if Pos('# PROP BASE Intermediate_Dir',ss)=1 then ss:='# PROP BASE Intermediate_Dir ""';
      if Pos('# PROP Output_Dir',ss)=1 then ss:='# PROP Output_Dir ""';
      if Pos('# PROP Intermediate_Dir',ss)=1 then ss:='# PROP Intermediate_Dir ""';
      i:=Pos('ADD BASE LINK32',ss); if (i>0) and (j=0) then ss:=ss+' /dll';
      i:=Pos('ADD LINK32',ss); if (i>0) and (j=0) then ss:=ss+' /dll';
      i:=Pos('ADD BASE F90',ss); if (i>0) and (j=0) then ss:=ss+' /dll';
      i:=Pos('ADD F90',ss); if (i>0) and (j=0) then ss:=ss+' /dll /threads';
    end;
    List[k]:=ss;    ssu:=AnsiUpperCase(ss);
    i:=Pos('/DEFINE:"',ssu); if i>0 then
      begin Macros:=Copy(ssu,i+9,255);
        i:=Pos('"',Macros); if i>0 then Macros:=Copy(Macros,1,i-1);
        Macros:='F2F '+Macros;
      end;
    if (Copy(ssu,1,9)='SOURCE=.\') or (Copy(ssu,1,10)='SOURCE=".\') then
    begin
      if not added then
      begin added:=true;                                      // add ComFort.*
        List.Insert(k,'SOURCE=..\ComFort.F90'); List.Insert(k+1,'# End Source File');
        List.Insert(k+2,'# Begin Source File'); List.Insert(k+3,'SOURCE=..\_ComFort.c'); List.Insert(k+4,'# End Source File');
//        List.Insert(k+5,'# Begin Source File'); List.Insert(k+6,'SOURCE=..\CompuServ.lib');   List.Insert(k+7,'# End Source File');
//        List.Insert(k+8,'# Begin Source File'); Inc(k,9);
        List.Insert(k+5,'# Begin Source File'); Place:=k+5; Inc(k,6);
      end;
      if (ssu='SOURCE=.\LONGJUMP.F90') or       // remove LongJump
         (ssu='SOURCE=.\COMFORT.F90')  or       // remove ComFort.*
         (ssu='SOURCE=.\_COMFORT.C') then
            Repeat List.Delete(k);  ss:=List[k];  Until (Copy(ss,1,9)='SOURCE=.\') or (k=List.Count);  // (bad if it stays the last!)
      i:=Pos('"',ssu); if i=8 then begin Delete(ssu,Length(ssu),1); Delete(ssu,8,1); ss:=ssu; end;  // filename in quotas - rudely !!!
      CurName:=Copy(ss,10,255);
      w:=AnsiUpperCase(ExtractFileExt(CurName));
      if(w='.F') or (w='.FOR') or (w='.F90') then
       begin Params[1]:=dd+CurName; Params[2]:=d+'\'+CurName;
         Params[3]:='';  HeadName:=pr;
         F2F(nil);                                                 // convert all Fortran Sources
       end  else System.Insert('.',ss,8);   // change .\ to ..\
// - do not use it!    end else if not CopyFile(dd+CurName,d+'\'+CurName) then ShowMessage('!!!!');
    end;
    List[k]:=ss;
  end;
//  if (Pos('NOCOMPUSERV',OwnMacro)=0) and (Place>0) then         // Fully converted project needs CompuServ.LIB
//    begin List.Insert(Place,'# Begin Source File'); List.Insert(Place+1,'SOURCE=..\CompuServ.lib');   List.Insert(Place+2,'# End Source File'); end;
  for k:=1 to List.Count do
  begin ss:=List[k-1];  ssu:=AnsiUpperCase(ss);
    if Pos('# ADD F90 ',ssu)=1 then    // insert F2F & PIVOT conditional variables into Fortran settings
    begin i:=Pos('/DEFINE:"',ssu);
      if i=0 then Insert('/define:"'+Pivot+OwnMacro+'F2F" ',ss,11)
             else Insert(Pivot+OwnMacro+'F2F ',ss,i+9);
      List[k-1]:=ss;
      List.Insert(k,'# ADD CPP /nologo /c');
    end;
  end;
  List.SaveToFile(LastFile); List.Clear; List.Free; List:=nil;
  ShowMessage('The converted project "'+pr+'"'#13 +'You can see in a directory'#13 +d);
  WholeProject:=false; Params[1]:=''; Params[2]:=''; Params[3]:=''; Silent:=false;
end;

procedure TForm1.mnuHelpClick(Sender: TObject);
begin
  Memo1.BringToFront;
end;

procedure TForm1.CheckedItemClick(Sender: TObject);
begin
  With Sender as TMenuItem do Checked:=not Checked;
end;

procedure TForm1.mnuConsolesClick(Sender: TObject);
begin
  Console:=InputBox('Enter list of console units','',Console);
end;

procedure TForm1.mnuNameClick(Sender: TObject);
begin
  HeadName:=InputBox('Enter DLL Name','Needed only for main file',HeadName);
end;

procedure TForm1.RedirectClick(Sender: TObject);
begin
  With Sender as TMenuItem do
    RedirUnits[Tag]:=InputBox(Caption,'Logical Unit Number needed',RedirUnits[Tag]);
end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  Case Key of
    VK_ESCAPE:Memo1.SendToBack;
  end;
end;


end.
