unit Minuit_Client;

//       N Params    Iterations    AsTime(sec.)
//          8           400          10
//         18          1600          40
//         25          2200          60
//         48         10000         300  

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, TeEngine, Series, StdCtrls, SapNedit, TeeProcs, Chart;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    Splitter1: TSplitter;
    Memo1: TMemo;
    Chart1: TChart;
    NParams: TINumEdit;
    btStart: TButton;
    Series1: TLineSeries;
    btControl: TButton;
    Button2: TButton;
    Button3: TButton;
    neTime: TINumEdit;
    procedure btStartClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    Procedure EventProcessing( Sender:TObject; var evName:OleVariant; var evValue:OleVariant);
    procedure btControlClick(Sender: TObject);  // "var" - essentially!
  private
    { Private declarations }
    state:integer;
    nParRead:integer;
    Val_FCN:string;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation
{$R *.DFM}

Uses CompuServ_TLB, SapTools;
Var Server:TComputationalServer;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Server:=TComputationalServer.Create(Self);
  Server.OnEvent:=EventProcessing;
end;

procedure TForm1.btStartClick(Sender: TObject);
var s:string;
begin Val_FCN:='';
  s:=ExtractFilePath(Application.ExeName);
  s:=Server.ExecuteDLL(s+'Converted_Minuit\Minuit.dll','Possible ParameterLine');
  if s<>'' then  begin  ShowMessage(s); Exit; end;
  Chart1.Series[0].Clear;  State:=0; nParRead:=0;
  Chart1.Series[0].AddXY(1,0,'',clTeeColor);
  Server.Resume;
end;

procedure TForm1.btControlClick(Sender: TObject);
begin if not Assigned(Server) then ShowMessage('Not running!') else With Server do
  Case (Sender as TButton).Tag of
    1: Suspend;
    2: Resume;
    3: Terminate;
  end;
end;


Procedure TForm1.EventProcessing( Sender:TObject; var evName:OleVariant; var evValue:OleVariant);  // "var" - essentially!
var s:string; i,NPar:integer;  x,FCN:Double;
begin s:=' ';
  if evName='Give_Line' then       // command line request via "Read(*,...)"
  begin neTime.Value:=Server.Time;
    if Val_FCN<>'' then            // request "Calculate FCN for me" - answer is ready yet!
       begin Server.AnswerFromClient:=Val_FCN; Val_FCN:='';  Exit; end;
    Inc(State);
    Case State of
      1: s:='set title';
      2: s:='Summa (X(i)-i)**2 has global minimum=0  if X(i)=i';
      3: s:='parameters';
      4: begin Inc(nParRead);
           s:=IntToStr(nParRead)+' ''X'+IntToStr(NParRead)+'''  0. 0.1';
           if nParRead>NParams.Value then s:='' else Dec(State);
         end;
      5: s:='seek 20';
      6: s:='simplex';
      7: s:='minimize';
      8: s:='exit';
      else s[1]:=Chr(0);          // EOF simulation
    end;
    Server.AnswerFromClient:=s;  Exit;
  end;
  s:=evValue;
  if evName='FCN' then            // FCN value request via spec. " Write(*,*) '%%%<FCN ...' "
  begin  NPar:=GetIntegerNumber(s);
    FCN:=0;  for i:=1 to NPar do begin x:=GetRealNumber(s); FCN:=FCN+sqr(x-i); end;
    Val_FCN:=FloatToStr(FCN);
    Exit;
  end;
  if evName='PAINT' then
  begin i:=GetIntegerNumber(s); FCN:=GetRealNumber(s);
    With Chart1.Series[0] do
    begin
      AddXY(i,FCN,'',clTeeColor);
      if Count > 40 then for i:=1 to 20 do Delete(0);
    end;
    Exit;
  end;
  if s<>'' then Memo1.Lines.Add(s);
end;

end.
