unit SAPTools;

interface

Uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, Math,
  Menus, IniFiles, Registry, Buttons, ExtCtrls, StdCtrls, FileCtrl,ComCtrls, ShellAPI,
  ShlObj, ComObj, ActiveX, WinSock;


Type  TLanguage = (Russian,English); { maybe other - why not }
      TInt  = Longint;
      TReal = Double;
Type Fcomp2item = Function( P:pointer; n1,n2:integer ):boolean;

  TOwnFont = class
  private
    FName:string;
  public
    Constructor Create(aName:string);
    Destructor Destroy; override;
    Procedure Changed;
    Property Name:string read FName;
  end;

  THome = class
  private
    info:_osversioninfo;
    FNT:boolean;
    FMask:string;
    procedure SetNewFmask(mask:string);
  public
    InitDir:string;     // initial directory (where .EXE file)
    CurDir:string;      // current directory
    Files:TStringList;  // files in there
    SubDirs:TStringList;// and its SubDirectories
    Params:TStringList; // parameters
    IniFile:string;     // .INI file ( the same name as EXE )
    Constructor Create;
    Destructor Destroy; override;
    Property Windows_NT:boolean read FNT;
    Property FileMask:string read FMask write SetNewFmask;
  end;

Const TrayMessage = WM_USER+2;
Type TFormOnSystemTray = class(TForm)
  protected
    Present:boolean;
    Procedure HookMinimize(Var Msg:TMessage); message WM_SYSCOMMAND;
    Procedure HookMaximize(var Msg : TMessage); message TrayMessage;
  public
    Procedure OnTray(yes:boolean);  // work with System Tray :  Put/Remove
end;

type
  TShortcut = class
  private
    Buf:array[0..MAX_PATH] of Char;
    wcLinkName: array[0..MAX_PATH] of WideChar;
    Location:string;
     sl : IShellLink;
    ppf : IPersistFile;
  protected
    Procedure CreateForAnyWhere(aTitle:string; Where:integer);
  public
    Title:string;            // Link = DesktopFolder+'\'+Title + '.lnk'    !!!
    Executable: String;      // Full Path to executable file
    IconPath: String;        // Full path to file containing icon
    IconIndex: Integer;      // if more than 1 icon
    WorkDir: String;         // Working dir.
    Args: String;            // Arguments
    Description: String;     // Description - not very useful
    Constructor CreateForDesktop(aTitle:string);
    Constructor CreateForPrograms(aTitle:string);
    Constructor CreateForStartMenu(aTitle:string);
    Constructor Create(aTitle:string; Where:integer);
    Function Exist:boolean;
    Procedure PutToDestination;
    Procedure RemoveFromDestination;
  end;

Var Home:THome;

Const Language:TLanguage = English;
      NumberRepresentationSize:integer = 10;
      DefaultMantisSize:integer = 4;
      SmallEnoughToBeReplacedByZero:TReal=0;

Function RealToStr(r:TReal; m:integer):string;
Function RealToStrFix(r:TReal; n:integer; m:integer):string;
Function Replicate(s:string; k:integer):string;
Function GetFragment(var s:string):string;
Function GetRealNumber(var s:string):TReal;
Function GetIntegerNumber(var s:string):integer;
Function StrToReal(s:string):TReal;
Function ExpandString(s:string; n:integer):string;
Function LeftFromImage(Source:string; Image:string):string;
Procedure Sh_Sort( P:pointer; N:integer; Comp:Fcomp2item );
Function  LatinTranscription(s:string):string;
Function  RusTranscription(s:string):string;
Function  ShortFileName(s:string):string;
Function  SizeOfFile(filename:string):integer;
Function CopyFile(FFrom,FTo:string):boolean;    { file copying }
Function KillFile(Fname:string):boolean;        { kill given file }
Function KillDirectory(DirName:string):boolean; { kill the whole directory recursively }
Function ExecuteFile(FileName, Params, DefaultDir: string): integer;
Procedure ExecuteDosCommand(CommandLine,DefaultDir:string);
Function GetHomeDir:string;                     // Where is my EXE-file
Procedure SetHScroll(ListBox:TListBox);
Procedure Dos2Win(var s:string);
Procedure Win2Dos(var s:string);
Procedure Delay(msecs : Longint);
Function ClientValidation:string;               // see install.pas
Function InstallMe(Title:string):string;
Procedure StampOut;
Procedure WhereIam;
Procedure GoHome;
Procedure Shuffle(var M:array of integer;  N:integer);
Function MyHostName:string;
Function Host2IP(Host:string):string;
Procedure HScroll(ListBox:TListBox);

implementation

uses SapDLG;

Function Replicate(s:string; k:integer):string;
begin Result:=''; While k>0 do begin Dec(k); Result:=Result+s; end;  end;

Function LeftFromImage(Source:string; Image:string):string;
var i:integer;
begin
  i:=Pos(Image,Source);
  if i=0 then Result:=Source else Result:=Copy(Source,1,i-1);
end;

Procedure HScroll(ListBox:TListBox);
var i,j,m:integer;
begin m := 0;
  for I := 1 to ListBox.Items.Count do
  begin
    j:=ListBox.Canvas.TextWidth(ListBox.Items[i-1]);
    if m<j then m:=j;
  end;
  SendMessage(ListBox.Handle,LB_SETHORIZONTALEXTENT,m+5,0);
end;


Function RealToStr(r:TReal; m:integer):string;
//          
var i:integer;
begin DecimalSeparator:='.'; // DecimalSeparator can be changed from outside!
  Result:=FloatToStrF(r,ffGeneral,NumberRepresentationSize,2);
  if m<0 then Exit;
  i:=Pos(',',Result); if i>0 then Result[i]:='.';
  i:=Pos('.',Result); if i=0 then Exit;
  if Pos('E',Result)>0 then Exit;
  if m=0 then Dec(i);
  Result:=Copy(Result,1,i+m);
end;

Function RealToStrFix(r:TReal; n:integer; m:integer):string;
//          
//        N 
var i:integer; rr:TReal;
begin
  if abs(r)<SmallEnoughToBeReplacedByZero then rr:=0 else rr:=r;
  Result:=RealToStr(rr,m);
  i:=Length(Result); if n<2 then Exit;
  if i<=n then Result:=Replicate(' ',n-i)+Result else
  begin i:=Pos('.',Result);
    if (i=0) or (i>n) then Result:='*'+Copy(Result,1,n-1) else
    if i=n then Result:=' '+Copy(Result,1,n-1) else Result:=Copy(Result,1,n);
  end;
end;

Function GetFragment(var s:string):string;
var i:integer;
begin
  s:=Trim(s);  i:=Pos(' ',s);
  if i=0 then begin Result:=s; s:=''; end else
    begin Result:=Copy(s,1,i-1); Delete(s,1,i); end;
end;

Function GetRealNumber(var s:string):TReal;
var i:integer;
    t:string;
begin DecimalSeparator:='.'; // DecimalSeparator can be changed from outside!
  t:=GetFragment(s);
  Result:=0; if t='' then Exit;
  i:=Pos(',',t); if i>0 then t[i]:='.';
  if Pos('.',t)=Length(t) then t:=t+'0';  { Val gives error for "0."  ! }
  Val(t,Result,i); if i=0 then Exit;
  Case Language of
    Russian:ShowMessage('... '+t+'  '+s+Chr(13)+'   ^     !');
    English:ShowMessage('... '+t+'  '+s+Chr(13)+'   ^  Illegal number !');
  end;
  Result:=-999999;
end;

Function GetIntegerNumber(var s:string):integer;
begin Result:=Round(GetRealNumber(s)); end;

Function StrToReal(s:string):TReal;
var s1:string;
begin s1:=s; Result:=GetRealNumber(s1); end;

Function ExpandString(s:string; n:integer):string;
begin Result:=s;
  While Length(Result)<n do Result:=Result+' ';
  if Length(Result)>n then Result:=Copy(Result,1,n);
end;

Procedure SetHScroll(ListBox:TListBox);
//       ListBox
Var i,w,m:integer;
begin m:=0;
  for I := 0 to ListBox.Items.Count - 1 do
  begin
    w:=ListBox.Canvas.TextWidth(ListBox.Items.Strings[I]);
    if m<w then m:=w;
  end;
  SendMessage(ListBox.Handle,LB_SETHORIZONTALEXTENT,((m+2)*Screen.Width) div 640, 0);
end;

procedure Delay(msecs : Longint);
var FirstTick : Longint;
begin FirstTick := LongInt(GetTickCount);
repeat Application.ProcessMessages;
until LongInt(GetTickCount) - FirstTick > msecs;
end;

Procedure Sh_Sort( P:pointer; N:integer; Comp:Fcomp2item );
Var step,i,j,k:integer;
begin if N<2 then Exit;
  step:=4; if N>25 then Repeat step:=3*step+1; Until step>=N;
  Repeat step:=(step-1) div 3;  for i:=1 to step do  { simple insert inside }
    begin j:=i;
      Repeat Inc(j,step); k:=j; if k<=N then
      	Repeat Dec(k,step); Until Comp(P,k,k+step) or (k=i);
      Until j>N-step;
    end;
  Until step=1;
end;

Function  LatinTranscription(s:string):string;
var i:integer;
begin Result:='';
  for i:=1 to Length(s) do  Case s[i] of
      ' '  : Result:=Result+'_';     //       
    '','': Result:=Result+'A';
    '','': Result:=Result+'B';
    '','': Result:=Result+'V';
    '','': Result:=Result+'G';
    '','': Result:=Result+'D';
    '','': Result:=Result+'E';
    '','': Result:=Result+'H';
    '','': Result:=Result+'Z';
    '','': Result:=Result+'I';
    '','': Result:=Result+'J';
    '','': Result:=Result+'K';
    '','': Result:=Result+'L';
    '','': Result:=Result+'M';
    '','': Result:=Result+'N';
    '','': Result:=Result+'O';
    '','': Result:=Result+'P';
    '','': Result:=Result+'R';
    '','': Result:=Result+'S';
    '','': Result:=Result+'T';
    '','': Result:=Result+'U';
    '','': Result:=Result+'F';
    '','': Result:=Result+'X';
    '','': Result:=Result+'C';
    '','': Result:=Result+'c';
    '','': Result:=Result+'s';
    '','': Result:=Result+'c';
    '','': Result:=Result+'y';
    '','': Result:=Result+'Y';
    '','': Result:=Result+'y';
    '','': Result:=Result+'e';
    '','': Result:=Result+'W';
    '','': Result:=Result+'Q';
      else   Result:=Result+UpCase(s[i]);
  end;
end;

Function  RusTranscription(s:string):string;
var i:integer;
begin Result:='';
  for i:=1 to Length(s) do  Case s[i] of
    'a','A': Result:=Result+'';
    'b','B': Result:=Result+'';
    'c','C': Result:=Result+'';
    'e','E': Result:=Result+'';
    'h','H': Result:=Result+'';
    'k','K': Result:=Result+'';
    'm','M': Result:=Result+'';
    'o','O': Result:=Result+'';
    'p','P': Result:=Result+'';
    't','T': Result:=Result+'';
    'x','X': Result:=Result+'';
      else   Result:=Result+s[i];
  end;
  Result:=AnsiUpperCase(Result);
end;


Procedure Dos2Win(var s:string);
var i,k:integer;
begin
  for i:=1 to Length(s) do
  begin k:=Ord(s[i]);
    if (k>=$E0) and (k<=$EF) then s[i]:=Chr(k+16)
      else if(k>=$80) and (k<=$AF) then s[i]:=Chr(k+64)
        else Case k of
               $F0: s[i]:=Chr($A8);
               $F1: s[i]:=Chr($B8);
             end;
   end;
end;

Procedure Win2Dos(var s:string);
var i:integer;
begin
  for i:=1 to Length(s) do
  if Ord(s[i]) > $BF then
    if Ord(s[i]) > $EF then s[i]:=Chr(Ord(s[i])-16)
        else s[i]:=Chr(Ord(s[i])-64)
     else Case Ord(s[i]) of
            $A8: s[i]:=Chr($F0);
            $B8: s[i]:=Chr($F1);
          end;
end;

Function GetHomeDir:string;  { Where is my EXE-file }
begin Result:=ExtractFileDir(Application.Exename); end;

   { TOwnFont }

Constructor TOwnFont.Create(aName:string);
begin
  Inherited Create;
  FName:=GetHomeDir+'\'+aName+'.fon';
  if not FileExists(FName) then FName:=GetHomeDir+'\'+aName+'.ttf';
  AddFontResource( PChar(FName) );   // set own font
  Changed;
end;

Procedure TOwnFont.Changed;
begin
//  SendMessage(HWND_BroadCast, WM_FontChange,0,0);
end;

Destructor TOwnFont.Destroy;
begin
  RemoveFontResource(PChar(Fname));   // kill own font
  Inherited Destroy;
end;

Constructor THome.Create;
var i:integer; sr:TSearchRec;
begin inherited Create;
  InitDir:=GetHomeDir;  CurDir:=GetCurrentDir;
  Params:=TStringList.Create;
  for i:=0 to Min(ParamCount,9) do Params.Add(AnsiUpperCase(ParamStr(i)));
  IniFile:=ChangeFileExt(ParamStr(0),'.INI');  FMask:='*.*';
  SubDirs:=TStringList.Create;  Files:=TStringList.Create;
  FindFirst(CurDir+'\*.*',faAnyFile,sr);  FindNext(sr);   // skip "."&".."
  While FindNext(sr)=0 do
    if sr.Attr=faDirectory then SubDirs.Add(sr.Name) else Files.Add(sr.Name);
  FindClose(sr);
  FileMask:='*.*';
  info.dwOsVersionInfoSize:=SizeOf(info);  GetVersionEx(info);
  FNT:=(info.dwPlatformId=VER_PLATFORM_WIN32_NT);
end;

Destructor THome.Destroy;
begin
  Params.Free;   SubDirs.Free;  Files.Free;
  Inherited Destroy;
end;

Procedure THome.SetNewFmask(mask:string);
var sr:TSearchRec;
begin FMask:=mask;  Files.Clear;
  if FindFirst(CurDir+'\'+mask,faArchive,sr)=0 then
    Repeat Files.Add(sr.Name) Until FindNext(sr)<>0;
  FindClose(sr);
end;

Procedure WhereIam;
begin  Home.Free; Home:=THome.Create; end;

Procedure GoHome;
begin  ChDir(Home.InitDir);  WhereIam;  end;

Procedure Shuffle(var M:array of integer;  N:integer);
var i,j,k:integer;
begin Randomize;
  for i:=0 to N-1 do begin j:=Random(N); k:=M[i]; M[i]:=M[j]; M[j]:=k; end;
end;

{ ------------------      -----------
}
Function ShortFileName(s:string):string;
var i:integer;
begin
  Result:=AnsiUpperCase(Copy(LatinTranscription(Trim(s)),1,8));
  for i:=1 to Length(Result) do
    if Pos(Result[i],' .*?|<>":')>0 then Result[i]:='_';
end;

Function  SizeOfFile(filename:string):integer;
var f:file of byte;
begin Result:=-1;
  {$I-} AssignFile(f,filename); Reset(f); {$I+}
  if IoResult<>0 then Exit;
  Result:=FileSize(f);
  CloseFile(f);
end;

Function CopyFile(FFrom,FTo:string):boolean;  { file copying }
var S,D:file of byte;
    b:array[1..1000] of byte;
    L:integer;
begin  Result:=(FFrom=FTo); if Result then Exit;
  {$I-} Assign(S,FFrom); Reset(S); {$I+} if IoResult<>0 then Exit;
  {$I-} Assign(D,FTo); Rewrite(D); {$I+} if IoResult<>0 then begin Close(S); Exit; end;
  While not Eof(S) do begin BlockRead(S,b,Sizeof(b),L); BlockWrite(D,b,L); end;
  Close(S); Close(D); Result:=true;
end;

Function KillFile(Fname:string):boolean;     { kill file }
var F:file of byte;
begin
  {$I-} Assign(F,FName); Reset(F); {$I+} Result:=(IoResult=0);
  if not Result then Exit;
  {$I-} Rewrite(F); CloseFile(F); Erase(F); {$I+} Result:=(IoResult=0);
end;

Function KillDirectory(DirName:string):boolean; {   }
var Rec:TSearchRec;
    j:integer; d:string;
begin d:=DirName;
  if d[Length(d)]='\' then d:=Copy(d,1,Length(d)-1);
  j:=FindFirst(d+'\*.*',faAnyFile,Rec);
  While j=0 do
  begin
    if Rec.Name[1]<>'.' then
      if (Rec.Attr and faDirectory)>0
        then KillDirectory(d+'\'+Rec.Name)
        else KillFile(d+'\'+Rec.Name);
    j:=FindNext(Rec);
  end;
  FindClose(Rec);
  {$I-} RmDir(d); {$I+}
  Result:=(IoResult=0);
end;


function ExecuteFile(FileName, Params, DefaultDir: string): integer;
var zFileName, zParams, zDir: array[0..255] of Char;  s:string;
begin
  Result := ShellExecute(Application.MainForm.Handle, nil,
    StrPCopy(zFileName, FileName), StrPCopy(zParams, Params),
    StrPCopy(zDir, DefaultDir), SW_SHOWNORMAL);
  if Result<33 then
  begin s:=' '+IntToStr(Result)+'   '#13+'  '+FileName+'  '+Params;
    if Length(Home.InitDir)>20 then s:=s+''#13+'      ?';
    ShowMessage(s);
  end;
end;

Procedure ExecuteDosCommand(CommandLine,DefaultDir:string);
Const RedirectedOutput='output.dos';
var rout:string; t,n:integer;
begin t:=0;
  rout:=GetHomeDir+'\'+RedirectedOutput;  DeleteFile(rout);
  n:=ExecuteFile(GetHomeDir+'\install.exe','EXECUTE '+CommandLine+' > '+rout,DefaultDir);
  Repeat t:=t+1000; Delay(1000); Until DeleteFile(rout) or (t>10000);
  GoHome;
  if (n>32) and not Home.Windows_NT then TerminateThread(n,0);    // -   NT ???
end;

Const ownmark=' Copyright (C) SapSoft. 2001. V3.16 ';   // Attention: Length fixed !!!
Const Crypt='\qsweecrutryiutiyo.pdaastdifngshtjaklllz.xecxvebCNHMEQCWKE en otk6i7l2l0 ';
Type
   TInstaller=record
      Signature:string[Length(ownmark)];
      ClientName:string[80];
      ProductName:string[80];
      WrittenBy:string[80];
      KeyWord:string[20];
      Computer:array[0..32] of byte;
      InstallLimit,RunLimit,TrialPeriod:SmallInt;
      PrevDat,LastDat:LongInt;
    end;
Var Installer:TInstaller;
    buf:array[0..SizeOf(TInstaller)-1] of byte absolute Installer;

Function ClientValidation:string;     // see install.pas
Const MinVol=1000000;
Var f:file;
    s:string; i,n:integer;
begin Result:='';
  s:=''; i:=1; While i<Length(Crypt) do begin s:=s+Crypt[i]; Inc(i,2); end;
  if (DiskFree(0)<MinVol) or (DiskFree(3)<MinVol) then
    ShowMessage('       .'#13+
                '     , '#13+
                '   !     1 MB !');
  if not FileExists(GetHomeDir+'\'+Copy(s,14,11)) then Exit;
// comment 4 lines below to put security off
  n:=ExecuteFile(Copy(s,14,11),Copy(s,25,12),GetHomeDir);
  Delay(2000);                        // enough to Validate !?
  if (n>32) and not Home.Windows_NT then TerminateThread(n,0);
  if FileExists(GetHomeDir+'\'+Copy(s,1,13)) then Exit;

 {$I-} Assign(f,Copy(s,14,11)); Reset(f,1); {$I+}
  if IoResult<>0 then Exit;
  Seek(f,Filesize(f)-512);  BlockRead(f,Buf,SizeOf(Buf)); CloseFile(f);
  for i:=0 to SizeOf(TInstaller)-1 do Buf[i]:=(Buf[i] xor ((3*i+7) mod 256));
  s:=Installer.ClientName;   Dos2Win(s);  Installer.ClientName:=s;
  s:=Installer.ProductName;  Dos2Win(s);  Installer.ProductName:=s;
  s:=Installer.KeyWord;      Dos2Win(s);  Installer.KeyWord:=s;
  s:=Installer.WrittenBy;    Dos2Win(s);  Installer.WrittenBy:=s;
  Installer.Signature:=ownMark;  Result:=Installer.ClientName;
end;

Function InstallMe(Title:string):string;
Var f:file; fs:file of TInstaller;
    s:string; i,n:integer; Face:TInstaller;
begin Result:='';
  s:=''; i:=1; While i<Length(Crypt) do begin s:=s+Crypt[i]; Inc(i,2); end;
  n:=ExecuteFile(GetHomeDir+'\install.exe','GETFACE','');
  Delay(2000);  if (n>32) and not Home.Windows_NT then TerminateThread(n,0);
  AssignFile(fs,GetHomeDir+'\'+Copy(s,1,13)); Reset(fs); Read(fs,Face); CloseFile(fs);
 {$I-} Assign(f,Copy(s,14,11)); Reset(f,1); {$I+}
  if IoResult<>0 then Exit;
  s:=InputBox('  ','',Title); Result:=s;
  Seek(f,Filesize(f)-512);  BlockRead(f,Buf,SizeOf(Buf));
  for i:=0 to SizeOf(TInstaller)-1 do Buf[i]:=(Buf[i] xor ((3*i+7) mod 256));
  Installer.Computer:=Face.Computer; Win2Dos(s); if s<>'' then Installer.ClientName:=s;
  for i:=0 to SizeOf(TInstaller)-1 do Buf[i]:=(Buf[i] xor ((3*i+7) mod 256));
  Seek(f,Filesize(f)-512);  BlockWrite(f,Buf,SizeOf(Buf)); CloseFile(f);
end;

Procedure StampOut;
var s:string;
begin
  ClientValidation;
  With Installer do
  begin s:='Run Limit:'+IntToStr(RunLimit)+'  Trial Period:'+IntToStr(TrialPeriod);
    if LastDat=0 then s:='' else s:=s+'   ( only '+IntToStr(LastDat-PrevDat)+' days left! )'#13;
    ShowMessage(Trim(ProductName)+'    written by  '+Trim(WrittenBy)+' '#13+
                 s+'Client Name: '+Trim(ClientName));
  end;
end;

// -----------  TShortCut class :

Constructor TShortcut.Create(aTitle:string; Where:integer);
begin  CreateForAnyWhere(aTitle,Where);  end;

Constructor TShortcut.CreateForDesktop(aTitle:string);
begin  CreateForAnyWhere(aTitle,CSIDL_DESKTOP);  end;

Constructor TShortcut.CreateForPrograms(aTitle:string);
begin  CreateForAnyWhere(aTitle,CSIDL_PROGRAMS);  end;

Constructor TShortcut.CreateForStartMenu(aTitle:string);
begin  CreateForAnyWhere(aTitle,CSIDL_STARTMENU);  end;

Procedure TShortcut.CreateForAnyWhere(aTitle:string; Where:integer);
Var  iID: PItemIDList;
  wfd: TWin32FindData;
begin Title:=aTitle; Executable:=''; IconPath:='';
  if SHGetSpecialFolderLocation(Application.Handle,Where,iID)<>NOERROR then Exit;
  SHGetPathFromIDList(iID, Buf);  Location:=Buf;
  Location:=Location+'\'+Title+'.lnk';            // Full path to given Location
  OleCheck(CoInitialize(nil));                    // COM open
  try
    OleCheck(CoCreateInstance(CLSID_ShellLink,nil,CLSCTX_INPROC_SERVER,IID_IShellLinkA,sl));
    OleCheck(sl.QueryInterface(IPersistFile, ppf));
    MultiByteToWideChar(CP_ACP,0,PChar(Location),-1,wcLinkName,MAX_PATH);
    OleCheck(ppf.Load(wcLinkName, STGM_READ));
    OleCheck(sl.GetPath(Buf,MAX_PATH,wfd,SLR_ANY_MATCH));  Executable:=Buf;
    OleCheck(sl.GetIconLocation(Buf,MAX_PATH,IconIndex));  IconPath:=Buf;
    OleCheck(sl.GetWorkingDirectory(Buf,MAX_PATH));        WorkDir:=Buf;
    OleCheck(sl.GetArguments(Buf,MAX_PATH));               Args:=Buf;
    OleCheck(sl.GetDescription(Buf,MAX_PATH));             Description:=Buf;
  except
    on EOleSysError do  Executable:='';
  end;
  CoUnInitialize;                                 // COM close
end;

Function TShortcut.Exist:boolean;
begin Result:=(Executable<>''); end;              // false if virtual folder like MyComputer !!!

Procedure TShortcut.PutToDestination;
begin if not Exist then Exit;
  OleCheck(CoInitialize(nil));                    // COM open
  try
    OleCheck(sl.SetPath(PChar(Executable)));
    if IconPath='' then StrPCopy(Buf,Executable) else StrPCopy(Buf,IconPath);
    OleCheck(sl.SetIconLocation(Buf,IconIndex));
    if WorkDir='' then StrPCopy(Buf,ExtractFilePath(Executable)) else StrPCopy(Buf,WorkDir);
    OleCheck(sl.SetWorkingDirectory(Buf));
    OleCheck(sl.SetArguments(PChar(Args)));
    OleCheck(sl.SetDescription(PChar(Description)));
    OleCheck(ppf.Save(wcLinkName, true));
  finally
    CoUnInitialize;                               // COM close
  end;
end;

Procedure TShortcut.RemoveFromDestination;
begin if not Exist then Exit;
  if DeleteFile(Location) then Executable:='';
end;

Procedure TFormOnSystemTray.OnTray(yes:boolean);  // Put on System Tray (yes/no)
Var Nim:TNotifyIconData;
Begin  if yes=Present then Exit;  Present:=yes;
  With Nim do     // fill parameter area for Shell_NotifyIcon
  Begin cbSize:=SizeOf(Nim); Wnd:=Handle; uID:=1;
    if Assigned(Icon) then hicon:=Icon.Handle else hicon:=0;
    uFlags:=NIF_ICON or NIF_MESSAGE or NIF_TIP;
    uCallbackMessage:=TrayMessage; StrPCopy(szTip,Copy(Caption,1,60));
  End;
  if yes then begin Shell_NotifyIcon(Nim_Add,@Nim);    ShowWindow(Handle,SW_HIDE); end
         else begin Shell_NotifyIcon(Nim_Delete,@Nim); ShowWindow(Handle,SW_SHOWNORMAL); end;
End;

Procedure TFormOnSystemTray.HookMinimize(Var Msg:TMessage); // message WM_SYSCOMMAND;
Begin  Case Msg.WParam of
         SC_MINIMIZE : OnTray(true);
         SC_CLOSE    : OnTray(false);
          else         inherited;
       End;
End;

Procedure TFormOnSystemTray.HookMaximize(var Msg : TMessage); // message TrayMessage;
Var p:tpoint;
begin Case Msg.LParam OF // What button pressed
    WM_LBUTTONUP,WM_LBUTTONDBLCLK: OnTray(false);
    WM_RBUTTONUP: Begin GetCursorPos(p); // Mouse Coord
                    SetForegroundWindow(Handle);
                    if Assigned(PopupMenu) then  PopupMenu.Popup(p.X,p.Y);
                    PostMessage(Handle,WM_NULL,0,0);
                  end;
  End;
End;


Var wsadata:Twsadata;

Function MyHostName:string;
Var buf:array[1..100] of char;
begin
  if GetHostName(@buf,sizeof(buf))<>0 then Result:='' else Result:=StrPas(@buf);
end;

Function Host2IP(Host:string):string;
Var p : PHOSTENT;
  sin_addr:TinAddr;
  h:string; i:integer;
begin Result:='';
  if Host='Self' then h:=MyHostName else h:=Host;
  i:=Pos('@',h); if i>0 then h:='mail.'+Copy(h,i+1,255);
  p := GetHostByName(pChar(h));    //  IP-    
  if not Assigned(p) then Exit;
  Move( p^.h_addr^[0], sin_addr, p^.h_length);
  Result := inet_ntoa(sin_addr);   // IP-      NNN.NNN.NNN.NNN
end;

Initialization
  Home:=THome.Create;
  WSAStartup($101,wsadata);
Finalization
  Home.Free;

end.



