!F2F:NO_TOUCH!
!
!    Auxiliary module for MPI-programs converted via  F2F
!
      Subroutine MPI_Start
      include 'comfort.h'
      data cf_NProc/1/, cf_MyProcess/0/, cf_CurUnit/0/,
     -     cf_RecCnt/1000*0/, cf_BufIo/' '/, cf_Ebuf/' '/, 
     -     fo_NameSuffix/''/, fo_HomePath/' '/, fo_FilePath/' '/,
     -     fo_FileName/' '/, fo_FileExt/' '/, fo_FullName/' '/, fo_MessEr/' '/
     -     fo_Console/-1/, fo_Error/0/,	  Termination_Type/0/
      Logical answer
!DEC$ IF DEFINED (MPI)
      data cf_MPICommunicator/MPI_COMM_WORLD/
      call MPI_INITIALIZED(answer,ierr)
      if(.not.answer) call MPI_INIT(ierr)      ! else init was done outside!
      call MPI_COMM_SIZE(cf_MPIcommunicator,cf_NProc,cf_ierr)
      call MPI_COMM_RANK(cf_MPIcommunicator,cf_MyProcess,cf_ierr)
!DEC$ ENDIF
      Return
      End

      Subroutine Normal_Termination    ! Use it instead of final "STOP" 
      include 'comfort.h'

      Termination_Type=0               ! OK
      goto 1
! ----------
      ENTRY cf_IO_Error                ! called from inside of DLL
      Termination_Type=3               ! 'I/O Error   '
      if(cf_BufIO.ne.' ') then
	    cf_BufIO='*** current processed record:'//cf_BufIO
		call Interface_IO(0)           ! 3 lines of swearing
      endif
      goto 3
! ----------
      ENTRY cf_Eof_Read                ! called from inside of DLL
      Termination_Type=4               ! 'End of File '   (2 lines of swearing)
  3   cf_BufIO=''
      if(cf_CurUnit.gt.0) then
      cf_BufIO='Error on unit 0000 record 000000 in file ' 
      Write(cf_BufIO(15:18),'(i4)',err=4) cf_CurUnit
      if(cf_CurUnit.gt.1000) goto 5
      Write(cf_BufIO(27:32),'(i6)',err=4) cf_RecCnt(cf_CurUnit)-1 
  5   inquire(unit=cf_CurUnit,name=cf_BufIO(42:140),err=4)
  4   call Interface_IO(0)  
      endif
! ----------------------------------------
      Entry cf_Instead_of_STOP                  ! called from inside of DLL
      if(cf_BufIO.ne.' ') call Interface_IO(0)  ! write final message if given 
  1   continue
      cf_BufIO=' finished successfully.'
      if(Termination_Type.eq.3) cf_BufIO=' I/O Error in '//cf_Ebuf
      if(Termination_Type.eq.4) cf_BufIO=' End of File in '//cf_Ebuf
      CALL Interface_IO(0)                      ! final special message 
      do i=1,1000                               ! closing all own opened files
        if(cf_RecCnt(i).ne.0) call Close_File(i)
      enddo 
      STOP                                      ! the simplest way !!! 
      END 

! ----------------------------------------
      Subroutine Interface_IO(job)                     ! 0:write, 1:read, -1:debug
      Integer*4 job
      include 'comfort.h'
      Equivalence(buf,cf_BufIO)                        ! MPI_BCast cannot get Character parameter !!!
      if(job.eq.1) then
        cf_BufIO=''                                    ! clear I/O buffer
        if(cf_MyProcess.eq.0) then
           if(cf_CurUnit.eq.0)  read(*,'(A)') cf_BufIO ! console or Formatted File Read
           if(cf_CurUnit.ne.0)  read(cf_CurUnit,'(A)') cf_BufIO 
        endif
!DEC$ IF DEFINED (MPI)
        if(cf_NProc.gt.1) call MPI_BCast(buf,
     -     MaxLBuf,MPI_CHARACTER,0,cf_MPICommunicator,cf_ierr) ! after Read 
!DEC$ ENDIF
      else
        n1=1
        n2=0
        if(cf_BufIO(1:1).eq.' ') n1=2                  ! maybe 1-st blank put by Fortran ! 
        if(cf_MyProcess.ne.0) n1=99999                 ! only root MPI-process does Console Write!
        do i=1,MaxLBuf
          if(cf_BufIO(i:i).eq.Char(250)) then          ! Char(250) simulates "/" in formats
            Call Buffer_Out(n1,n2) 
            n1=i+1
          endif
          if(cf_BufIO(i:i).ne.' ' ) n2=i 
        enddo
        Call Buffer_Out(n1,n2) 
        cf_BufIO=''                                    ! clear I/O buffer
      endif
      return
      End 

      Subroutine Buffer_Out(n1,n2)
      include 'comfort.h'
      if(n1.gt.n2) return
      if(cf_CurUnit.eq.0) write(*,'(A)') cf_BufIO(n1:n2)
      if(cf_CurUnit.ne.0) write(cf_CurUnit,'(A)') cf_BufIO(n1:n2)
      Return
      End
! ----------------------------------------

      Subroutine cf_NewUnit(Lun)                ! New logical Unit appears (OPEN)
      integer*4 Lun
      include 'comfort.h'
      cf_CurUnit=Lun
      if(Lun.ge.1.and.Lun.le.1000) cf_RecCnt(Lun)=1 ! initial record counter for active unit
      return

      Entry cf_NewRecord(Lun)                   ! Read/Write new record on current Unit
      cf_CurUnit=Lun
      if(Lun.ge.1.and.Lun.le.1000) 
     -   cf_RecCnt(Lun)=cf_RecCnt(lun)+1 ! increase record counter for active unit
      return
      End 
!
! -------------- stuff for opening files ------------------
!
      Function Len_Trim(s)
	Character*(*) s
        Len_Trim=0
	do i=1,Len(s)
	  if(s(i:i).ne.' ') Len_Trim=i
        enddo
	Return
	end
      
	Subroutine Concat(s1,s2)
	character*(*) s1,s2
	s1=s1(1:Len_Trim(s1))//s2
	return
	end

      Subroutine fo_SplitFileName(name)
      Character*(*) name
      Integer*4 i,j,k,p1,p2,p3
      Character*256 fn
      Character*8 badchars
      include 'comfort.h'
      data BadChars/':*?<>"''|'/
      fo_FilePath=''
      fo_FileName=''
      fo_FileExt='    '
      fo_error=1       ! Illegal File Name
      fo_MessEr='Illegal FileName: '//name
      j=Len_Trim(name) ! last non-blan
      if((name(j:j).eq.'''').or.(name(j:j).eq.'"')) j=j-1    ! maybe quotas
      i=1
      do while ((i.lt.j).and.(name(i:i).eq.' '))
        i=i+1          ! 1-st non-blan
      enddo
      if((name(i:i).eq.'''').or.(name(i:i).eq.'"')) i=i+1    ! maybe quotas
      k=j-i+1
      fn=name(i:j)     ! K characters without left blanks
      p1=0
      p2=0
      p3=0
      do i=1,k                           ! check for legal FileName
        if(fn(i:i).eq.'/') fn(i:i)='\'   ! replace Unix-style "/"
        j=IChar(fn(i:i))                 ! and UpperCase
        if(j.ge.IChar('a').and.j.le.IChar('z')) 
     -    fn(i:i)=Char(j+IChar('A')-IChar('a'))
        j=Index(badchars,fn(i:i))
        if(ichar(fn(i:i)).lt.ichar(' ') .or. j.gt.1) goto 999   ! illegal
        if(j.eq.1) then
          p1=2                           ! position ":" after Disk-letter 
          if(fn(1:2).eq.'\\') p1=Index(fn,':')
          if(i.gt.p1) goto 999           ! 2-nd ":"
        endif
        if(fn(i:i).eq.'\') p2=i
        if(fn(i:i).eq.'.') p3=i
      enddo
      fo_FullName=fn
      fo_error=0
      fo_MessEr=''
      fo_FilePath=''
      fo_FileExt='    '
      if(p3.gt.0) then
        fo_FileExt=fn(p3:k)
        fn(p3:k)='            '
        k=p3-1
      endif
      fo_FileName=fn(p1+1:k)
      if(p2.gt.p1) then
        fo_FilePath=fn(1:p2-1)
        fo_FileName=fn(p2+1:k)
      endif
  999 if(fo_error.ne.0) call fo_mess
      Return 
      End 

      Subroutine fo_mess
      include 'comfort.h'
      character*256 mess
      integer*4 n
      mess='Error XXX in File_Open: '//fo_MessEr
      write(mess(7:9),'(i3)',err=7) fo_error
      if(fo_error.eq.0) mess=fo_MessEr
      n=Len_Trim(mess)
  7   if(fo_console.eq.0) Write(*,'(A)',err=1) mess(1:n)           ! actually console
      if(fo_console.gt.0)
     -  Write(fo_console,'(A)',err=1) mess(1:n)  ! file
  1   return
      End 

      Subroutine Open_LogFile(Lun,name) !  if FileName starts with "+" open as "APPEND" !!! 
      include 'comfort.h'
      Character*(*) name
      Integer*4 Lun
      character*256 file,access
!   ---------
      fo_console=-1     ! block logging
      if(Lun.lt.1 .or. name.eq.'' .or. cf_MyProcess.ne.0) return
      file=name
      access='sequential'
      if(name(1:1).eq.'+') then
        file=file(2:256)
        access='APPEND'
      endif
      Call fo_SplitFileName(file)
      if(fo_error.ne.0) goto 1  
      fo_MessEr='Cannot open LogFile '//fo_FullName
      open(Lun,file=fo_FullName,err=9,status='unknown',
     -     form='FORMATTED',iostat=fo_error,access=access) 
      goto 2
  9   call Concat(fo_MessEr,'  Try to open in current directory ...')
      fo_FullName=fo_FileName
      if(fo_FileExt(1:1).eq.'.') call Concat(fo_FullName,fo_FileExt)
      open(Lun,file=fo_FullName,err=1,status='unknown',
     -  form='FORMATTED',iostat=fo_error,access=access) 
      call fo_Mess
  2   fo_MessEr=''
      fo_console=Lun   ! permit logging
      if(Lun.gt.0.and.Lun.lt.1000) then 
        cf_RecCnt(Lun) = 1         ! Unit got active
      endif
  1   continue
      Return
      End 

      Subroutine Open_NameFile(Lun,name) !  
      include 'comfort.h'
      Character*(*) name
      Character*256 name1,suffix
      Integer*4 Lun
	  Character*4 sts
	  Data sts/'.NAM'/                        ! standard NameFile Suffix
!   ---------------
      if(cf_MyProcess.ne.0) return
      suffix=sts
      if(suffix.eq.fo_NameSuffix) fo_NameSuffix=''
	  name1=name
      goto 1
   2  if(Suffix.eq.'') goto 11                ! without next attempt
      call Concat(fo_MessEr,'    Try to use suffix '//Suffix)
	call Concat(fo_MessEr,' ...')
      call fo_Mess
      Name1=Name
	call Concat(Name1,Suffix)
      if(suffix.ne.sts) suffix=''
      if(suffix.eq.sts) suffix=fo_NameSuffix
   1  Call fo_SplitFileName(name1)
      if(fo_error.ne.0) return                ! message done yet
      fo_MessEr='Cannot open NameFile '//fo_FullName
      open(Lun,file=fo_FullName,err=2,status='OLD',
     -   form='FORMATTED',iostat=fo_error) 
      fo_MessEr=''
      fo_HomePath=fo_FilePath
      if(Lun.gt.0.and.Lun.lt.1000) then 
        cf_RecCnt(Lun) = 1         ! Unit got active
      endif
  11  if(fo_Error.ne.0) call fo_Mess
      Return
      End

      Subroutine Open_File(Lun,file1,status,form) !  if FileName starts with "+" open as "APPEND" !!! 
      include 'comfort.h'
      integer*4 Lun,irecl
      character*(*) file1,status,form
      character*10 access,action,ff
	  character*256 file
      if(cf_MyProcess.ne.0) return
      file=file1
      access='sequential'
      if(file(1:1).eq.'+') then
        file=file(2:256)
        access='APPEND'
      endif
!
      action='readwrite'
      if(status(1:1).eq.'o' .or. status(1:1).eq.'O') action='read'  ! "OLD" status
      ff=form
      if(ff(1:1).eq.'u' .or. ff(1:1).eq.'U') ff='BINARY'  ! "Binary" instead of "UnFormatted"
      fo_Error=0
      fo_MessEr=' Unit XXXX: open as '//status
	call Concat(fo_MessEr,' '//ff)
	call Concat(fo_MessEr,' '//action)
	call Concat(fo_MessEr,' file '//file1)
      write(fo_MessEr(7:10),'(i4)',err=1) Lun
  1   call fo_Mess                            ! inform user what is doing
!
      Call fo_SplitFileName(file)
      if(fo_error.ne.0) return                ! message done yet
      fo_Error=2
      fo_MessEr='Cannot open file '//fo_FullName
      fHandle=0
      if(ff(1:1).eq.'d' .or. ff(1:1).eq.'D')       then        ! Dnnnnnn  - direct access file
        read(ff(2:7),'(i6)',err=99) irecl
        open(Lun,file=fo_FullName,err=99,status=status,
     -      access='DIRECT',recl=irecl,iostat=fo_error)
      elseif(status(1:1).eq.'s'.or.status(1:1).eq.'S') then    ! SCRATCH
        open(Lun,status='SCRATCH',err=99,form=ff,iostat=fo_Error)
      else
        open(Lun,file=fo_FullName,err=2,status=status,form=ff,
     -       iostat=fo_Error,access=access)
        goto 9
   2    if(fo_HomePath.eq.' ') goto 99                         ! not known 
        call Concat(fo_MessEr,'    Try to find in '//fo_HomePath)
	  call Concat(fo_MessEr,' ...')
        call fo_Mess
        fo_FullName=fo_HomePath
	  call Concat(fo_FullName,'\'//fo_FileName)
        if(fo_FileExt(1:1).eq.'.') call Concat(fo_FullName,fo_FileExt)
        fo_MessEr='Cannot open file '//fo_FullName
	  call Concat(fo_MessEr,'   It was the final attempt!')
        open(Lun,file=fo_FullName,err=99,status=status,form=ff,
     -       iostat=fo_Error,access=access)
      endif
   9  fo_Error=0
      fo_MessEr=''
      if(Lun.gt.0.and.Lun.lt.1000) cf_RecCnt(Lun) = 1        ! Unit got active
  99  if(fo_Error.ne.0) call fo_Mess
      Return
      End 

      Subroutine Close_File(Lun)    ! and delete file if Lun<0
      include 'comfort.h'
      integer*4 Lun,Luna
      if(cf_MyProcess.ne.0) return
      Luna=iabs(Lun)
      if(Lun.gt.0) Close(Lun) 
      if(Lun.lt.0) Close(Luna,Status='delete') 
      if(Luna.gt.0.and.Luna.lt.1000) cf_RecCnt(Luna) = 0     ! Unit got inactive
      Return 
      End 


